"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const List_1 = __importDefault(require("./views/collections/List"));
const Default_1 = __importDefault(require("./templates/Default"));
const api_1 = require("../api");
const Loading_1 = __importDefault(require("./elements/Loading"));
const StayLoggedIn_1 = __importDefault(require("./modals/StayLoggedIn"));
const Unlicensed_1 = __importDefault(require("./views/Unlicensed"));
const Dashboard = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Dashboard'))));
const ForgotPassword = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/ForgotPassword'))));
const Login = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Login'))));
const Logout = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Logout'))));
const NotFound = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/NotFound'))));
const Verify = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Verify'))));
const CreateFirstUser = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/CreateFirstUser'))));
const Edit = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/collections/Edit'))));
const EditGlobal = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Global'))));
const ResetPassword = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/ResetPassword'))));
const Unauthorized = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Unauthorized'))));
const Account = react_1.lazy(() => Promise.resolve().then(() => __importStar(require('./views/Account'))));
const Routes = () => {
    const [initialized, setInitialized] = react_1.useState(null);
    const { user, permissions, permissions: { canAccessAdmin }, refreshCookie } = config_provider_1.useAuth();
    const { admin: { user: userSlug }, routes, collections, globals, } = config_provider_1.useConfig();
    react_1.useEffect(() => {
        api_1.requests.get(`${routes.api}/${userSlug}/init`).then((res) => res.json().then((data) => {
            if (data && 'initialized' in data) {
                setInitialized(data.initialized);
            }
        }));
    }, [routes, userSlug]);
    return (react_1.default.createElement(react_1.Suspense, { fallback: react_1.default.createElement(Loading_1.default, null) },
        react_1.default.createElement(react_router_dom_1.Route, { path: routes.admin, render: ({ match }) => {
                if (initialized === false) {
                    return (react_1.default.createElement(react_router_dom_1.Switch, null,
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/create-first-user` },
                            react_1.default.createElement(CreateFirstUser, { setInitialized: setInitialized })),
                        react_1.default.createElement(react_router_dom_1.Route, null,
                            react_1.default.createElement(react_router_dom_1.Redirect, { to: `${match.url}/create-first-user` }))));
                }
                if (initialized === true) {
                    return (react_1.default.createElement(react_router_dom_1.Switch, null,
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/login` },
                            react_1.default.createElement(Login, null)),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/logout` },
                            react_1.default.createElement(Logout, null)),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/logout-inactivity` },
                            react_1.default.createElement(Logout, { inactivity: true })),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/forgot` },
                            react_1.default.createElement(ForgotPassword, null)),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/reset/:token` },
                            react_1.default.createElement(ResetPassword, null)),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/unlicensed` },
                            react_1.default.createElement(Unlicensed_1.default, null)),
                        collections.map((collection) => {
                            if (collection?.auth?.verify) {
                                return (react_1.default.createElement(react_router_dom_1.Route, { key: `${collection.slug}-verify`, path: `${match.url}/${collection.slug}/verify/:token`, exact: true },
                                    react_1.default.createElement(Verify, { collection: collection })));
                            }
                            return null;
                        }),
                        react_1.default.createElement(react_router_dom_1.Route, { render: () => {
                                if (user) {
                                    if (canAccessAdmin) {
                                        return (react_1.default.createElement(Default_1.default, null,
                                            react_1.default.createElement(react_router_dom_1.Switch, null,
                                                react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/`, exact: true },
                                                    react_1.default.createElement(Dashboard, null)),
                                                react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}/account` },
                                                    react_1.default.createElement(Account, null)),
                                                collections.map((collection) => (react_1.default.createElement(react_router_dom_1.Route, { key: `${collection.slug}-list`, path: `${match.url}/collections/${collection.slug}`, exact: true, render: (routeProps) => {
                                                        if (permissions?.collections?.[collection.slug]?.read?.permission) {
                                                            return (react_1.default.createElement(List_1.default, Object.assign({}, routeProps, { collection: collection })));
                                                        }
                                                        return react_1.default.createElement(Unauthorized, null);
                                                    } }))),
                                                collections.map((collection) => (react_1.default.createElement(react_router_dom_1.Route, { key: `${collection.slug}-create`, path: `${match.url}/collections/${collection.slug}/create`, exact: true, render: (routeProps) => {
                                                        if (permissions?.collections?.[collection.slug]?.create?.permission) {
                                                            return (react_1.default.createElement(Edit, Object.assign({}, routeProps, { collection: collection })));
                                                        }
                                                        return react_1.default.createElement(Unauthorized, null);
                                                    } }))),
                                                collections.map((collection) => (react_1.default.createElement(react_router_dom_1.Route, { key: `${collection.slug}-edit`, path: `${match.url}/collections/${collection.slug}/:id`, exact: true, render: (routeProps) => {
                                                        if (permissions?.collections?.[collection.slug]?.read?.permission) {
                                                            return (react_1.default.createElement(Edit, Object.assign({ isEditing: true }, routeProps, { collection: collection })));
                                                        }
                                                        return react_1.default.createElement(Unauthorized, null);
                                                    } }))),
                                                globals && globals.map((global) => (react_1.default.createElement(react_router_dom_1.Route, { key: `${global.slug}`, path: `${match.url}/globals/${global.slug}`, exact: true, render: (routeProps) => {
                                                        if (permissions?.globals?.[global.slug]?.read?.permission) {
                                                            return (react_1.default.createElement(EditGlobal, Object.assign({}, routeProps, { global: global })));
                                                        }
                                                        return react_1.default.createElement(Unauthorized, null);
                                                    } }))),
                                                react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}*` },
                                                    react_1.default.createElement(NotFound, null)))));
                                    }
                                    if (canAccessAdmin === false) {
                                        return react_1.default.createElement(Unauthorized, null);
                                    }
                                    return react_1.default.createElement(Loading_1.default, null);
                                }
                                if (user === undefined) {
                                    return react_1.default.createElement(Loading_1.default, null);
                                }
                                return react_1.default.createElement(react_router_dom_1.Redirect, { to: `${match.url}/login` });
                            } }),
                        react_1.default.createElement(react_router_dom_1.Route, { path: `${match.url}*` },
                            react_1.default.createElement(NotFound, null))));
                }
                return null;
            } }),
        react_1.default.createElement(StayLoggedIn_1.default, { refreshCookie: refreshCookie })));
};
exports.default = react_router_dom_1.withRouter(Routes);
