"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const Plus_1 = __importDefault(require("../../icons/Plus"));
const X_1 = __importDefault(require("../../icons/X"));
const Chevron_1 = __importDefault(require("../../icons/Chevron"));
require("./index.scss");
const icons = {
    plus: Plus_1.default,
    x: X_1.default,
    chevron: Chevron_1.default,
};
const baseClass = 'btn';
const ButtonContents = ({ children, icon }) => {
    const BuiltInIcon = icons[icon];
    return (react_1.default.createElement("span", { className: `${baseClass}__content` },
        children && (react_1.default.createElement("span", { className: `${baseClass}__label` }, children)),
        icon && (react_1.default.createElement("span", { className: `${baseClass}__icon` },
            react_1.isValidElement(icon) && icon,
            BuiltInIcon && react_1.default.createElement(BuiltInIcon, null)))));
};
const Button = (props) => {
    const { className, type = 'button', el, to, url, children, onClick, disabled, icon, iconStyle = 'without-border', buttonStyle = 'primary', round, size = 'medium', iconPosition = 'right', } = props;
    const classes = [
        baseClass,
        className && className,
        buttonStyle && `${baseClass}--style-${buttonStyle}`,
        icon && `${baseClass}--icon`,
        iconStyle && `${baseClass}--icon-style-${iconStyle}`,
        (icon && !children) && `${baseClass}--icon-only`,
        disabled && `${baseClass}--disabled`,
        round && `${baseClass}--round`,
        size && `${baseClass}--size-${size}`,
        iconPosition && `${baseClass}--icon-position-${iconPosition}`,
    ].filter(Boolean).join(' ');
    function handleClick(event) {
        if (type !== 'submit' && onClick)
            event.preventDefault();
        if (onClick)
            onClick(event);
    }
    const buttonProps = {
        type,
        className: classes,
        onClick: handleClick,
    };
    switch (el) {
        case 'link':
            return (react_1.default.createElement(react_router_dom_1.Link, Object.assign({}, buttonProps, { to: to || url }),
                react_1.default.createElement(ButtonContents, { icon: icon }, children)));
        case 'anchor':
            return (react_1.default.createElement("a", Object.assign({}, buttonProps, { href: url }),
                react_1.default.createElement(ButtonContents, { icon: icon }, children)));
        default:
            return (react_1.default.createElement("button", Object.assign({ type: "submit" }, buttonProps),
                react_1.default.createElement(ButtonContents, { icon: icon }, children)));
    }
};
exports.default = Button;
