"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const getInitialState_1 = __importDefault(require("./getInitialState"));
const flattenTopLevelFields_1 = __importDefault(require("../../../../utilities/flattenTopLevelFields"));
const Pill_1 = __importDefault(require("../Pill"));
const Plus_1 = __importDefault(require("../../icons/Plus"));
const X_1 = __importDefault(require("../../icons/X"));
require("./index.scss");
const baseClass = 'column-selector';
const reducer = (state, { type, payload }) => {
    if (type === 'enable') {
        return [
            ...state,
            payload,
        ];
    }
    if (type === 'replace') {
        return [
            ...payload,
        ];
    }
    return state.filter((remainingColumn) => remainingColumn !== payload);
};
const ColumnSelector = (props) => {
    const { collection, collection: { admin: { useAsTitle, defaultColumns, }, }, handleChange, } = props;
    const [initialColumns, setInitialColumns] = react_1.useState([]);
    const [fields] = react_1.useState(() => flattenTopLevelFields_1.default(collection.fields));
    const [columns, dispatchColumns] = react_1.useReducer(reducer, initialColumns);
    react_1.useEffect(() => {
        if (typeof handleChange === 'function')
            handleChange(columns);
    }, [columns, handleChange]);
    react_1.useEffect(() => {
        const { columns: initializedColumns } = getInitialState_1.default(fields, useAsTitle, defaultColumns);
        setInitialColumns(initializedColumns);
    }, [fields, useAsTitle, defaultColumns]);
    react_1.useEffect(() => {
        dispatchColumns({ payload: initialColumns, type: 'replace' });
    }, [initialColumns]);
    return (react_1.default.createElement("div", { className: baseClass }, fields && fields.map((field, i) => {
        const isEnabled = columns.find((column) => column === field.name);
        return (react_1.default.createElement(Pill_1.default, { onClick: () => dispatchColumns({ payload: field.name, type: isEnabled ? 'disable' : 'enable' }), alignIcon: "left", key: field.name || i, icon: isEnabled ? react_1.default.createElement(X_1.default, null) : react_1.default.createElement(Plus_1.default, null), pillStyle: isEnabled ? 'dark' : undefined, className: `${baseClass}__active-column` }, field.label));
    })));
};
exports.default = ColumnSelector;
