"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_toastify_1 = require("react-toastify");
const react_router_dom_1 = require("react-router-dom");
const modal_1 = require("@faceless-ui/modal");
const config_provider_1 = require("@payloadcms/config-provider");
const Button_1 = __importDefault(require("../Button"));
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const context_1 = require("../../forms/Form/context");
const useTitle_1 = __importDefault(require("../../../hooks/useTitle"));
const api_1 = require("../../../api");
require("./index.scss");
const baseClass = 'delete-document';
const DeleteDocument = (props) => {
    const { title: titleFromProps, id, collection: { admin: { useAsTitle, }, slug, labels: { singular, } = {}, } = {}, } = props;
    const { serverURL, routes: { api, admin } } = config_provider_1.useConfig();
    const { setModified } = context_1.useForm();
    const [deleting, setDeleting] = react_1.useState(false);
    const { closeAll, toggle } = modal_1.useModal();
    const history = react_router_dom_1.useHistory();
    const title = useTitle_1.default(useAsTitle) || id;
    const titleToRender = titleFromProps || title;
    const modalSlug = `delete-${id}`;
    const addDefaultError = react_1.useCallback(() => {
        react_toastify_1.toast.error(`There was an error while deleting ${title}. Please check your connection and try again.`);
    }, [title]);
    const handleDelete = react_1.useCallback(() => {
        setDeleting(true);
        setModified(false);
        api_1.requests.delete(`${serverURL}${api}/${slug}/${id}`, {
            headers: {
                'Content-Type': 'application/json',
            },
        }).then(async (res) => {
            try {
                const json = await res.json();
                if (res.status < 400) {
                    closeAll();
                    return history.push({
                        pathname: `${admin}/collections/${slug}`,
                        state: {
                            status: {
                                message: `${singular} "${title}" successfully deleted.`,
                            },
                        },
                    });
                }
                closeAll();
                if (json.errors) {
                    react_toastify_1.toast.error(json.errors);
                }
                addDefaultError();
                return false;
            }
            catch (e) {
                return addDefaultError();
            }
        });
    }, [addDefaultError, closeAll, history, id, singular, slug, title, admin, api, serverURL, setModified]);
    if (id) {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("button", { type: "button", className: `${baseClass}__toggle`, onClick: (e) => {
                    e.preventDefault();
                    toggle(modalSlug);
                } }, "Delete"),
            react_1.default.createElement(modal_1.Modal, { slug: modalSlug, className: baseClass },
                react_1.default.createElement(Minimal_1.default, null,
                    react_1.default.createElement("h1", null, "Confirm deletion"),
                    react_1.default.createElement("p", null,
                        "You are about to delete the",
                        ' ',
                        singular,
                        ' ',
                        "\"",
                        react_1.default.createElement("strong", null, titleToRender),
                        "\". Are you sure?"),
                    react_1.default.createElement(Button_1.default, { buttonStyle: "secondary", type: "button", onClick: deleting ? undefined : () => toggle(modalSlug) }, "Cancel"),
                    react_1.default.createElement(Button_1.default, { onClick: deleting ? undefined : handleDelete }, deleting ? 'Deleting...' : 'Confirm')))));
    }
    return null;
};
exports.default = DeleteDocument;
