"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_toastify_1 = require("react-toastify");
const modal_1 = require("@faceless-ui/modal");
const Button_1 = __importDefault(require("../Button"));
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
require("./index.scss");
const baseClass = 'generate-confirmation';
const GenerateConfirmation = (props) => {
    const { setKey, highlightField, } = props;
    const { toggle } = modal_1.useModal();
    const modalSlug = 'generate-confirmation';
    const handleGenerate = () => {
        setKey();
        toggle(modalSlug);
        react_toastify_1.toast.success('New API Key Generated.', { autoClose: 3000 });
        highlightField(true);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Button_1.default, { size: "small", buttonStyle: "secondary", onClick: () => {
                toggle(modalSlug);
            } }, "Generate new API key"),
        react_1.default.createElement(modal_1.Modal, { slug: modalSlug, className: baseClass },
            react_1.default.createElement(Minimal_1.default, null,
                react_1.default.createElement("h1", null, "Confirm Generation"),
                react_1.default.createElement("p", null,
                    "Generating a new API key will",
                    ' ',
                    react_1.default.createElement("strong", null, "invalidate"),
                    ' ',
                    "the previous key.",
                    ' ',
                    "Are you sure you wish to continue?"),
                react_1.default.createElement(Button_1.default, { buttonStyle: "secondary", type: "button", onClick: () => {
                        toggle(modalSlug);
                    } }, "Cancel"),
                react_1.default.createElement(Button_1.default, { onClick: handleGenerate }, "Generate")))));
};
exports.default = GenerateConfirmation;
