"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_animate_height_1 = __importDefault(require("react-animate-height"));
const SearchFilter_1 = __importDefault(require("../SearchFilter"));
const ColumnSelector_1 = __importDefault(require("../ColumnSelector"));
const WhereBuilder_1 = __importDefault(require("../WhereBuilder"));
const SortComplex_1 = __importDefault(require("../SortComplex"));
const Button_1 = __importDefault(require("../Button"));
require("./index.scss");
const baseClass = 'list-controls';
const ListControls = (props) => {
    const { handleChange, collection, enableColumns = true, enableSort = false, setSort, collection: { fields, admin: { useAsTitle, }, }, } = props;
    const [titleField, setTitleField] = react_1.useState(null);
    const [search, setSearch] = react_1.useState('');
    const [columns, setColumns] = react_1.useState([]);
    const [where, setWhere] = react_1.useState({});
    const [visibleDrawer, setVisibleDrawer] = react_1.useState();
    react_1.useEffect(() => {
        if (useAsTitle) {
            const foundTitleField = fields.find((field) => field.name === useAsTitle);
            if (foundTitleField) {
                setTitleField(foundTitleField);
            }
        }
    }, [useAsTitle, fields]);
    react_1.useEffect(() => {
        const newState = {
            columns,
        };
        if (search) {
            newState.where = {
                and: [
                    search,
                ],
            };
        }
        if (where) {
            if (!search) {
                newState.where = {
                    and: [],
                };
            }
            newState.where.and.push(where);
        }
        handleChange(newState);
    }, [search, columns, where, handleChange]);
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement("div", { className: `${baseClass}__wrap` },
            react_1.default.createElement(SearchFilter_1.default, { handleChange: setSearch, fieldName: titleField ? titleField.name : undefined, fieldLabel: titleField ? titleField.label : undefined }),
            react_1.default.createElement("div", { className: `${baseClass}__buttons` },
                react_1.default.createElement("div", { className: `${baseClass}__buttons-wrap` },
                    enableColumns && (react_1.default.createElement(Button_1.default, { className: `${baseClass}__toggle-columns`, buttonStyle: visibleDrawer === 'columns' ? undefined : 'secondary', onClick: () => setVisibleDrawer(visibleDrawer !== 'columns' ? 'columns' : undefined), icon: "chevron", iconStyle: "none" }, "Columns")),
                    react_1.default.createElement(Button_1.default, { className: `${baseClass}__toggle-where`, buttonStyle: visibleDrawer === 'where' ? undefined : 'secondary', onClick: () => setVisibleDrawer(visibleDrawer !== 'where' ? 'where' : undefined), icon: "chevron", iconStyle: "none" }, "Filters"),
                    enableSort && (react_1.default.createElement(Button_1.default, { className: `${baseClass}__toggle-sort`, buttonStyle: visibleDrawer === 'sort' ? undefined : 'secondary', onClick: () => setVisibleDrawer(visibleDrawer !== 'sort' ? 'sort' : undefined), icon: "chevron", iconStyle: "none" }, "Sort"))))),
        enableColumns && (react_1.default.createElement(react_animate_height_1.default, { className: `${baseClass}__columns`, height: visibleDrawer === 'columns' ? 'auto' : 0 },
            react_1.default.createElement(ColumnSelector_1.default, { collection: collection, handleChange: setColumns }))),
        react_1.default.createElement(react_animate_height_1.default, { className: `${baseClass}__where`, height: visibleDrawer === 'where' ? 'auto' : 0 },
            react_1.default.createElement(WhereBuilder_1.default, { handleChange: setWhere, collection: collection })),
        enableSort && (react_1.default.createElement(react_animate_height_1.default, { className: `${baseClass}__sort`, height: visibleDrawer === 'sort' ? 'auto' : 0 },
            react_1.default.createElement(SortComplex_1.default, { handleChange: setSort, collection: collection })))));
};
exports.default = ListControls;
