"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const RenderCustomComponent_1 = __importDefault(require("../../utilities/RenderCustomComponent"));
const Chevron_1 = __importDefault(require("../../icons/Chevron"));
const LogOut_1 = __importDefault(require("../../icons/LogOut"));
const Menu_1 = __importDefault(require("../../icons/Menu"));
const CloseMenu_1 = __importDefault(require("../../icons/CloseMenu"));
const Icon_1 = __importDefault(require("../../graphics/Icon"));
const Account_1 = __importDefault(require("../../graphics/Account"));
const Localizer_1 = __importDefault(require("../Localizer"));
require("./index.scss");
const baseClass = 'nav';
const DefaultNav = () => {
    const { permissions } = config_provider_1.useAuth();
    const [menuActive, setMenuActive] = react_1.useState(false);
    const history = react_router_dom_1.useHistory();
    const { collections, globals, routes: { admin, }, } = config_provider_1.useConfig();
    const classes = [
        baseClass,
        menuActive && `${baseClass}--menu-active`,
    ].filter(Boolean).join(' ');
    react_1.useEffect(() => history.listen(() => {
        setMenuActive(false);
    }), [history]);
    return (react_1.default.createElement("aside", { className: classes },
        react_1.default.createElement("div", { className: `${baseClass}__scroll` },
            react_1.default.createElement("header", null,
                react_1.default.createElement(react_router_dom_1.Link, { to: admin, className: `${baseClass}__brand` },
                    react_1.default.createElement(Icon_1.default, null)),
                react_1.default.createElement("button", { type: "button", className: `${baseClass}__mobile-menu-btn`, onClick: () => setMenuActive(!menuActive) },
                    menuActive && (react_1.default.createElement(CloseMenu_1.default, null)),
                    !menuActive && (react_1.default.createElement(Menu_1.default, null)))),
            react_1.default.createElement("div", { className: `${baseClass}__wrap` },
                react_1.default.createElement("span", { className: `${baseClass}__label` }, "Collections"),
                react_1.default.createElement("nav", null, collections && collections.map((collection, i) => {
                    const href = `${admin}/collections/${collection.slug}`;
                    if (permissions?.collections?.[collection.slug]?.read.permission) {
                        return (react_1.default.createElement(react_router_dom_1.NavLink, { activeClassName: "active", key: i, to: href },
                            react_1.default.createElement(Chevron_1.default, null),
                            collection.labels.plural));
                    }
                    return null;
                })),
                (globals && globals.length > 0) && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement("span", { className: `${baseClass}__label` }, "Globals"),
                    react_1.default.createElement("nav", null, globals.map((global, i) => {
                        const href = `${admin}/globals/${global.slug}`;
                        if (permissions?.globals?.[global.slug].read.permission) {
                            return (react_1.default.createElement(react_router_dom_1.NavLink, { activeClassName: "active", key: i, to: href },
                                react_1.default.createElement(Chevron_1.default, null),
                                global.label));
                        }
                        return null;
                    })))),
                react_1.default.createElement("div", { className: `${baseClass}__controls` },
                    react_1.default.createElement(Localizer_1.default, null),
                    react_1.default.createElement(react_router_dom_1.Link, { to: `${admin}/account`, className: `${baseClass}__account` },
                        react_1.default.createElement(Account_1.default, null)),
                    react_1.default.createElement(react_router_dom_1.Link, { to: `${admin}/logout`, className: `${baseClass}__log-out` },
                        react_1.default.createElement(LogOut_1.default, null)))))));
};
const Nav = () => {
    const { admin: { components: { Nav: CustomNav, } = {
        Nav: undefined,
    }, } = {}, } = config_provider_1.useConfig();
    return (react_1.default.createElement(RenderCustomComponent_1.default, { CustomComponent: CustomNav, DefaultComponent: DefaultNav }));
};
exports.default = Nav;
