"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const window_info_1 = require("@faceless-ui/window-info");
const scroll_info_1 = require("@faceless-ui/scroll-info");
const useThrottledEffect_1 = __importDefault(require("../../../hooks/useThrottledEffect"));
const PopupButton_1 = __importDefault(require("./PopupButton"));
require("./index.scss");
const baseClass = 'popup';
const Popup = (props) => {
    const { render, align = 'center', size = 'small', color = 'light', button, buttonType = 'default', children, showOnHover = false, horizontalAlign = 'left', initActive = false, onToggleOpen, } = props;
    const buttonRef = react_1.useRef(null);
    const contentRef = react_1.useRef(null);
    const [active, setActive] = react_1.useState(initActive);
    const [verticalAlign, setVerticalAlign] = react_1.useState('top');
    const [forceHorizontalAlign, setForceHorizontalAlign] = react_1.useState(null);
    const { y: scrollY } = scroll_info_1.useScrollInfo();
    const { height: windowHeight } = window_info_1.useWindowInfo();
    const handleClickOutside = (e) => {
        if (contentRef.current.contains(e.target)) {
            return;
        }
        setActive(false);
    };
    useThrottledEffect_1.default(() => {
        if (contentRef.current && buttonRef.current) {
            const { height: contentHeight, width: contentWidth, right: contentRightEdge, } = contentRef.current.getBoundingClientRect();
            const { y: buttonYCoord } = buttonRef.current.getBoundingClientRect();
            const windowWidth = window.innerWidth;
            const distanceToRightEdge = windowWidth - contentRightEdge;
            const distanceToLeftEdge = contentRightEdge - contentWidth;
            if (horizontalAlign === 'left' && distanceToRightEdge <= 0) {
                setForceHorizontalAlign('right');
            }
            else if (horizontalAlign === 'right' && distanceToLeftEdge <= 0) {
                setForceHorizontalAlign('left');
            }
            else if (horizontalAlign === 'center' && (distanceToLeftEdge <= contentWidth / 2 || distanceToRightEdge <= contentWidth / 2)) {
                if (distanceToRightEdge > distanceToLeftEdge)
                    setForceHorizontalAlign('left');
                else
                    setForceHorizontalAlign('right');
            }
            else {
                setForceHorizontalAlign(null);
            }
            if (buttonYCoord > contentHeight) {
                setVerticalAlign('top');
            }
            else {
                setVerticalAlign('bottom');
            }
        }
    }, 500, [setVerticalAlign, contentRef, scrollY, windowHeight]);
    react_1.useEffect(() => {
        if (active) {
            document.addEventListener('mousedown', handleClickOutside);
        }
        else {
            document.removeEventListener('mousedown', handleClickOutside);
        }
        return () => {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, [active]);
    const classes = [
        baseClass,
        `${baseClass}--align-${align}`,
        `${baseClass}--size-${size}`,
        `${baseClass}--color-${color}`,
        `${baseClass}--v-align-${verticalAlign}`,
        `${baseClass}--h-align-${horizontalAlign}`,
        forceHorizontalAlign && `${baseClass}--force-h-align-${forceHorizontalAlign}`,
        active && `${baseClass}--active`,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes },
        react_1.default.createElement("div", { ref: buttonRef, className: `${baseClass}__wrapper` }, showOnHover
            ? (react_1.default.createElement("div", { className: `${baseClass}__on-hover-watch`, onMouseEnter: () => setActive(true), onMouseLeave: () => setActive(false) },
                react_1.default.createElement(PopupButton_1.default, { onToggleOpen: onToggleOpen, buttonType: buttonType, button: button, setActive: setActive, active: active })))
            : (react_1.default.createElement(PopupButton_1.default, { onToggleOpen: onToggleOpen, buttonType: buttonType, button: button, setActive: setActive, active: active }))),
        react_1.default.createElement("div", { className: `${baseClass}__content`, ref: contentRef },
            react_1.default.createElement("div", { className: `${baseClass}__wrap` },
                react_1.default.createElement("div", { className: `${baseClass}__scroll` },
                    render && render({ close: () => setActive(false) }),
                    children && children)))));
};
exports.default = Popup;
