"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const context_1 = require("../../forms/Form/context");
const Button_1 = __importDefault(require("../Button"));
const baseClass = 'preview-btn';
const PreviewButton = ({ generatePreviewURL }) => {
    const { token } = config_provider_1.useAuth();
    const { getFields } = context_1.useForm();
    const fields = getFields();
    if (generatePreviewURL && typeof generatePreviewURL === 'function') {
        const previewURL = generatePreviewURL(fields, token);
        return (react_1.default.createElement(Button_1.default, { el: "anchor", className: baseClass, buttonStyle: "secondary", url: previewURL }, "Preview"));
    }
    return null;
};
exports.default = PreviewButton;
