"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const Search_1 = __importDefault(require("../../icons/Search"));
const useDebounce_1 = __importDefault(require("../../../hooks/useDebounce"));
require("./index.scss");
const baseClass = 'search-filter';
const SearchFilter = (props) => {
    const { fieldName = 'id', fieldLabel = 'ID', handleChange, } = props;
    const [search, setSearch] = react_1.useState('');
    const debouncedSearch = useDebounce_1.default(search, 300);
    react_1.useEffect(() => {
        if (typeof handleChange === 'function') {
            handleChange(debouncedSearch ? {
                [fieldName]: {
                    like: debouncedSearch,
                },
            } : null);
        }
    }, [debouncedSearch, handleChange, fieldName]);
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement("input", { className: `${baseClass}__input`, placeholder: `Search by ${fieldLabel}`, type: "text", value: search, onChange: (e) => setSearch(e.target.value) }),
        react_1.default.createElement(Search_1.default, null)));
};
exports.default = SearchFilter;
