"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const ReactSelect_1 = __importDefault(require("../ReactSelect"));
const sortableFieldTypes_1 = __importDefault(require("../../../../fields/sortableFieldTypes"));
require("./index.scss");
const baseClass = 'sort-complex';
const sortOptions = [{ label: 'Ascending', value: '' }, { label: 'Descending', value: '-' }];
const SortComplex = (props) => {
    const { collection, handleChange, } = props;
    const [sortFields] = react_1.useState(() => collection.fields.reduce((fields, field) => {
        if (field.name && sortableFieldTypes_1.default.indexOf(field.type) > -1) {
            return [
                ...fields,
                { label: field.label, value: field.name },
            ];
        }
        return fields;
    }, []));
    const [sortField, setSortField] = react_1.useState(null);
    const [sortOrder, setSortOrder] = react_1.useState('-');
    react_1.useEffect(() => {
        if (sortField) {
            handleChange(`${sortOrder}${sortField}`);
        }
    }, [sortField, sortOrder, handleChange]);
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: `${baseClass}__wrap` },
                react_1.default.createElement("div", { className: `${baseClass}__select` },
                    react_1.default.createElement("div", { className: `${baseClass}__label` }, "Column to Sort"),
                    react_1.default.createElement(ReactSelect_1.default, { value: sortFields.find((field) => field.name === sortField), options: sortFields, onChange: setSortField })),
                react_1.default.createElement("div", { className: `${baseClass}__select` },
                    react_1.default.createElement("div", { className: `${baseClass}__label` }, "Order"),
                    react_1.default.createElement(ReactSelect_1.default, { value: sortOptions.find((order) => order.value === sortOrder), options: sortOptions, onChange: setSortOrder }))))));
};
exports.default = SortComplex;
