"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const File_1 = __importDefault(require("../../graphics/File"));
const getThumbnail_1 = __importDefault(require("../../../../uploads/getThumbnail"));
require("./index.scss");
const baseClass = 'thumbnail';
const Thumbnail = (props) => {
    const { filename, mimeType, staticURL, sizes, adminThumbnail, size, } = props;
    const { serverURL } = config_provider_1.useConfig();
    const thumbnail = getThumbnail_1.default(mimeType, staticURL, filename, sizes, adminThumbnail);
    const classes = [
        baseClass,
        `${baseClass}--size-${size || 'medium'}`,
    ].join(' ');
    return (react_1.default.createElement("div", { className: classes },
        thumbnail && (react_1.default.createElement("img", { src: `${serverURL}${thumbnail}`, alt: filename })),
        !thumbnail && (react_1.default.createElement(File_1.default, null))));
};
exports.default = Thumbnail;
