"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-a11y/click-events-have-key-events */
const react_1 = __importDefault(require("react"));
const Thumbnail_1 = __importDefault(require("../Thumbnail"));
require("./index.scss");
const baseClass = 'upload-card';
const UploadCard = (props) => {
    const { onClick, mimeType, sizes, filename, collection: { upload: { adminThumbnail, staticURL, } = {}, } = {}, } = props;
    const classes = [
        baseClass,
        typeof onClick === 'function' && `${baseClass}--has-on-click`,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes, onClick: typeof onClick === 'function' ? onClick : undefined },
        react_1.default.createElement(Thumbnail_1.default, Object.assign({ size: "expand" }, {
            mimeType, adminThumbnail, sizes, staticURL, filename,
        })),
        react_1.default.createElement("div", { className: `${baseClass}__filename` }, filename)));
};
exports.default = UploadCard;
