"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const RenderCustomComponent_1 = __importDefault(require("../../../utilities/RenderCustomComponent"));
const ReactSelect_1 = __importDefault(require("../../ReactSelect"));
const Button_1 = __importDefault(require("../../Button"));
const Date_1 = __importDefault(require("./Date"));
const Number_1 = __importDefault(require("./Number"));
const Text_1 = __importDefault(require("./Text"));
const useDebounce_1 = __importDefault(require("../../../../hooks/useDebounce"));
require("./index.scss");
const valueFields = {
    Date: Date_1.default,
    Number: Number_1.default,
    Text: Text_1.default,
};
const baseClass = 'condition';
const Condition = (props) => {
    const { fields, dispatch, value, orIndex, andIndex, } = props;
    const [activeField, setActiveField] = react_1.useState({ operators: [] });
    const [internalValue, setInternalValue] = react_1.useState(value.value);
    const debouncedValue = useDebounce_1.default(internalValue, 300);
    react_1.useEffect(() => {
        const newActiveField = fields.find((field) => value.field === field.value);
        if (newActiveField) {
            setActiveField(newActiveField);
        }
    }, [value, fields]);
    react_1.useEffect(() => {
        dispatch({
            type: 'update',
            orIndex,
            andIndex,
            value: debouncedValue || '',
        });
    }, [debouncedValue, dispatch, orIndex, andIndex]);
    const ValueComponent = valueFields[activeField.component] || valueFields.Text;
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement("div", { className: `${baseClass}__wrap` },
            react_1.default.createElement("div", { className: `${baseClass}__inputs` },
                react_1.default.createElement("div", { className: `${baseClass}__field` },
                    react_1.default.createElement(ReactSelect_1.default, { value: fields.find((field) => value.field === field.value), options: fields, onChange: (field) => dispatch({
                            type: 'update',
                            orIndex,
                            andIndex,
                            field,
                        }) })),
                react_1.default.createElement("div", { className: `${baseClass}__operator` },
                    react_1.default.createElement(ReactSelect_1.default, { value: activeField.operators.find((operator) => value.operator === operator.value), options: activeField.operators, onChange: (operator) => dispatch({
                            type: 'update',
                            orIndex,
                            andIndex,
                            operator,
                        }) })),
                react_1.default.createElement("div", { className: `${baseClass}__value` },
                    react_1.default.createElement(RenderCustomComponent_1.default, { CustomComponent: activeField?.props?.admin?.components?.Filter, DefaultComponent: ValueComponent, componentProps: {
                            ...activeField.props,
                            value: internalValue,
                            onChange: setInternalValue,
                        } }))),
            react_1.default.createElement("div", { className: `${baseClass}__actions` },
                react_1.default.createElement(Button_1.default, { icon: "x", round: true, buttonStyle: "icon-label", iconStyle: "with-border", onClick: () => dispatch({
                        type: 'remove',
                        orIndex,
                        andIndex,
                    }) }),
                react_1.default.createElement(Button_1.default, { icon: "plus", round: true, buttonStyle: "icon-label", iconStyle: "with-border", onClick: () => dispatch({
                        type: 'add',
                        relation: 'and',
                        orIndex,
                        andIndex: andIndex + 1,
                    }) })))));
};
exports.default = Condition;
