"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const Button_1 = __importDefault(require("../../../elements/Button"));
const Popup_1 = __importDefault(require("../../../elements/Popup"));
const BlockSelector_1 = __importDefault(require("../../field-types/Blocks/BlockSelector"));
require("./index.scss");
const baseClass = 'action-panel';
const ActionPanel = (props) => {
    const { addRow, removeRow, label = 'Row', blockType, blocks = [], rowIndex, isHovered, hasMaxRows, } = props;
    const classes = [
        baseClass,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes },
        react_1.default.createElement(Popup_1.default, { showOnHover: true, size: "wide", color: "dark", horizontalAlign: "center", buttonType: "custom", button: (react_1.default.createElement(Button_1.default, { className: `${baseClass}__remove-row`, round: true, buttonStyle: "none", icon: "x", iconPosition: "left", iconStyle: "with-border", onClick: () => removeRow(rowIndex) })) },
            "Remove\u00A0",
            label),
        !hasMaxRows && (react_1.default.createElement(react_1.default.Fragment, null, blockType === 'blocks'
            ? (react_1.default.createElement(Popup_1.default, { buttonType: "custom", size: "large", horizontalAlign: "center", button: (react_1.default.createElement(Button_1.default, { className: `${baseClass}__add-row`, round: true, buttonStyle: "none", icon: "plus", iconPosition: "left", iconStyle: "with-border" })), render: ({ close }) => (react_1.default.createElement(BlockSelector_1.default, { blocks: blocks, addRow: addRow, addRowIndex: rowIndex, close: close, parentIsHovered: isHovered, watchParentHover: true })) }))
            : (react_1.default.createElement(Popup_1.default, { showOnHover: true, size: "wide", color: "dark", horizontalAlign: "center", buttonType: "custom", button: (react_1.default.createElement(Button_1.default, { className: `${baseClass}__add-row`, round: true, buttonStyle: "none", icon: "plus", iconPosition: "left", iconStyle: "with-border", onClick: () => addRow(rowIndex) })) },
                "Add\u00A0",
                label))))));
};
exports.default = ActionPanel;
