"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const Pill_1 = __importDefault(require("../../../elements/Pill"));
require("./index.scss");
const baseClass = 'section-title';
const SectionTitle = (props) => {
    const { label, path, readOnly } = props;
    const { value, setValue } = useFieldType_1.default({ path });
    const classes = [
        baseClass,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes },
        react_1.default.createElement(Pill_1.default, { pillStyle: "light-gray" }, label),
        react_1.default.createElement("input", { className: `${baseClass}__input`, id: path, value: value || '', placeholder: "Untitled", type: "text", name: path, onChange: setValue, readOnly: readOnly })));
};
exports.default = SectionTitle;
