"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_animate_height_1 = __importDefault(require("react-animate-height"));
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const ActionPanel_1 = __importDefault(require("./ActionPanel"));
const SectionTitle_1 = __importDefault(require("./SectionTitle"));
const PositionPanel_1 = __importDefault(require("./PositionPanel"));
const Button_1 = __importDefault(require("../../elements/Button"));
const context_1 = require("../FieldTypeGutter/context");
const FieldTypeGutter_1 = __importDefault(require("../FieldTypeGutter"));
const RenderFields_1 = __importStar(require("../RenderFields"));
require("./index.scss");
const baseClass = 'draggable-section';
const DraggableSection = (props) => {
    const { moveRow, addRow, removeRow, rowIndex, rowCount, parentPath, fieldSchema, label, blockType, fieldTypes, toggleRowCollapse, id, permissions, isOpen, readOnly, hasMaxRows, } = props;
    const [isHovered, setIsHovered] = react_1.useState(false);
    const { operation } = RenderFields_1.useRenderedFields();
    const classes = [
        baseClass,
        isOpen ? 'is-open' : 'is-closed',
        (isHovered && !readOnly) && 'is-hovered',
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement(react_beautiful_dnd_1.Draggable, { draggableId: id, index: rowIndex, isDragDisabled: readOnly }, (providedDrag) => (react_1.default.createElement("div", Object.assign({ ref: providedDrag.innerRef, className: classes, onMouseLeave: () => setIsHovered(false), onMouseOver: () => setIsHovered(true), onFocus: () => setIsHovered(true) }, providedDrag.draggableProps),
        react_1.default.createElement("div", { className: `${baseClass}__content-wrapper` },
            react_1.default.createElement(FieldTypeGutter_1.default, { variant: "left", dragHandleProps: providedDrag.dragHandleProps },
                react_1.default.createElement(PositionPanel_1.default, { moveRow: moveRow, rowCount: rowCount, positionIndex: rowIndex })),
            react_1.default.createElement("div", { className: `${baseClass}__render-fields-wrapper` },
                blockType === 'blocks' && (react_1.default.createElement("div", { className: `${baseClass}__section-header` },
                    react_1.default.createElement(SectionTitle_1.default, { label: label, path: `${parentPath}.${rowIndex}.blockName`, readOnly: readOnly }),
                    react_1.default.createElement(Button_1.default, { icon: "chevron", onClick: () => toggleRowCollapse(rowIndex), buttonStyle: "icon-label", className: `toggle-collapse toggle-collapse--is-${isOpen ? 'open' : 'closed'}`, round: true }))),
                react_1.default.createElement(react_animate_height_1.default, { height: isOpen ? 'auto' : 0, duration: 0 },
                    react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: false },
                        react_1.default.createElement(RenderFields_1.default, { operation: operation, readOnly: readOnly, fieldTypes: fieldTypes, key: rowIndex, permissions: permissions?.fields, fieldSchema: fieldSchema.map((field) => ({
                                ...field,
                                path: `${parentPath}.${rowIndex}${field.name ? `.${field.name}` : ''}`,
                            })) })))),
            react_1.default.createElement(FieldTypeGutter_1.default, { variant: "right", className: "actions", dragHandleProps: providedDrag.dragHandleProps }, !readOnly && (react_1.default.createElement(ActionPanel_1.default, Object.assign({ addRow: addRow, removeRow: removeRow, rowIndex: rowIndex, label: label, isHovered: isHovered, hasMaxRows: hasMaxRows }, props)))))))));
};
exports.default = DraggableSection;
