"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const context_1 = require("./context");
require("./index.scss");
const baseClass = 'field-type-gutter';
const FieldTypeGutter = ({ children, variant = 'left', verticalAlignment = 'sticky', className, dragHandleProps = {}, }) => {
    const allowNegativeGutter = context_1.useNegativeFieldGutter();
    const classes = [
        baseClass,
        `${baseClass}--${variant}`,
        `${baseClass}--v-align-${verticalAlignment}`,
        allowNegativeGutter && `${baseClass}--negative-gutter`,
        className && className,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", Object.assign({ className: classes }, dragHandleProps),
        react_1.default.createElement("div", { className: `${baseClass}__content-container` },
            react_1.default.createElement("div", { className: `${baseClass}__content` }, children))));
};
exports.default = FieldTypeGutter;
