"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const flatley_1 = require("flatley");
const reduceFieldsToValues_1 = __importDefault(require("./reduceFieldsToValues"));
const getDataByPath = (fields, path) => {
    const pathPrefixToRemove = path.substring(0, path.lastIndexOf('.') + 1);
    const name = path.split('.').pop();
    const data = Object.keys(fields).reduce((matchedData, key) => {
        if (key.indexOf(`${path}.`) === 0) {
            return {
                ...matchedData,
                [key.replace(pathPrefixToRemove, '')]: fields[key],
            };
        }
        return matchedData;
    }, {});
    const values = reduceFieldsToValues_1.default(data, true);
    const unflattenedData = flatley_1.unflatten(values);
    return unflattenedData?.[name];
};
exports.default = getDataByPath;
