"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flatley_1 = require("flatley");
const reduceFieldsToValues = (fields, flatten) => {
    const data = {};
    Object.keys(fields).forEach((key) => {
        if (!fields[key].disableFormData && fields[key].value !== undefined) {
            if (fields[key].stringify) {
                data[key] = JSON.stringify(fields[key].value);
            }
            else {
                data[key] = fields[key].value;
            }
        }
    });
    if (flatten) {
        const unflattened = flatley_1.unflatten(data, { safe: true });
        return unflattened;
    }
    return data;
};
exports.default = reduceFieldsToValues;
