"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const Error_1 = __importDefault(require("../../Error"));
const validations_1 = require("../../../../../fields/validations");
const Check_1 = __importDefault(require("../../../icons/Check"));
require("./index.scss");
const baseClass = 'checkbox';
const Checkbox = (props) => {
    const { name, path: pathFromProps, required, validate = validations_1.checkbox, label, onChange, disableFormData, admin: { readOnly, style, width, } = {}, } = props;
    const path = pathFromProps || name;
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { required });
        return validationResult;
    }, [validate, required]);
    const { value, showError, errorMessage, setValue, } = useFieldType_1.default({
        path,
        validate: memoizedValidate,
        disableFormData,
    });
    return (react_1.default.createElement("div", { className: [
            'field-type',
            baseClass,
            showError && 'error',
            value && `${baseClass}--checked`,
            readOnly && `${baseClass}--read-only`,
        ].filter(Boolean).join(' '), style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement("input", { type: "checkbox", name: path, id: path, checked: Boolean(value), readOnly: true }),
        react_1.default.createElement("button", { type: "button", onClick: readOnly ? undefined : () => {
                setValue(!value);
                if (typeof onChange === 'function')
                    onChange(!value);
            } },
            react_1.default.createElement("span", { className: `${baseClass}__input` },
                react_1.default.createElement(Check_1.default, null)),
            react_1.default.createElement("span", { className: `${baseClass}__label` }, label))));
};
exports.default = withCondition_1.default(Checkbox);
