"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_simple_code_editor_1 = __importDefault(require("react-simple-code-editor"));
const prism_core_1 = require("prismjs/components/prism-core");
require("prismjs/components/prism-clike");
require("prismjs/components/prism-javascript");
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const Label_1 = __importDefault(require("../../Label"));
const Error_1 = __importDefault(require("../../Error"));
const validations_1 = require("../../../../../fields/validations");
require("./index.scss");
const Code = (props) => {
    const { path: pathFromProps, name, required, validate = validations_1.code, admin: { readOnly, style, width, language, } = {}, label, minLength, maxLength, } = props;
    const [highlighter] = react_1.useState(() => {
        if (prism_core_1.languages[language]) {
            return (content) => prism_core_1.highlight(content, prism_core_1.languages[language]);
        }
        return (content) => content;
    });
    const path = pathFromProps || name;
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { minLength, maxLength, required });
        return validationResult;
    }, [validate, maxLength, minLength, required]);
    const { value, showError, setValue, errorMessage, } = useFieldType_1.default({
        path,
        validate: memoizedValidate,
        enableDebouncedValue: true,
    });
    const classes = [
        'field-type',
        'code',
        showError && 'error',
        readOnly && 'read-only',
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes, style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: path, label: label, required: required }),
        react_1.default.createElement(react_simple_code_editor_1.default, { value: value || '', onValueChange: readOnly ? () => null : setValue, highlight: highlighter, padding: 25, style: {
                backgroundColor: '#333333',
                color: 'white',
                fontFamily: '"Consolas", "Monaco", monospace',
                fontSize: 12,
                pointerEvents: readOnly ? 'none' : 'auto',
            } })));
};
exports.default = withCondition_1.default(Code);
