"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const Label_1 = __importDefault(require("../../Label"));
const Error_1 = __importDefault(require("../../Error"));
const context_1 = require("../../Form/context");
require("./index.scss");
const ConfirmPassword = () => {
    const { getField } = context_1.useWatchForm();
    const password = getField('password');
    const validate = react_1.useCallback((value) => {
        if (value === password?.value) {
            return true;
        }
        return 'Passwords do not match.';
    }, [password]);
    const { value, showError, setValue, errorMessage, } = useFieldType_1.default({
        path: 'confirm-password',
        disableFormData: true,
        validate,
        enableDebouncedValue: true,
    });
    const classes = [
        'field-type',
        'confirm-password',
        showError && 'error',
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: "confirm-password", label: "Confirm Password", required: true }),
        react_1.default.createElement("input", { value: value || '', onChange: setValue, type: "password", autoComplete: "off", id: "confirm-password", name: "confirm-password" })));
};
exports.default = ConfirmPassword;
