"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const DatePicker_1 = __importDefault(require("../../../elements/DatePicker"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const Label_1 = __importDefault(require("../../Label"));
const Error_1 = __importDefault(require("../../Error"));
const validations_1 = require("../../../../../fields/validations");
require("./index.scss");
const baseClass = 'date-time-field';
const DateTime = (props) => {
    const { path: pathFromProps, name, required, validate = validations_1.date, label, admin: { placeholder, readOnly, style, width, date, } = {}, } = props;
    const path = pathFromProps || name;
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { required });
        return validationResult;
    }, [validate, required]);
    const { value, showError, errorMessage, setValue, } = useFieldType_1.default({
        path,
        validate: memoizedValidate,
    });
    const classes = [
        'field-type',
        baseClass,
        showError && `${baseClass}--has-error`,
        readOnly && 'read-only',
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes, style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: path, label: label, required: required }),
        react_1.default.createElement("div", { className: `${baseClass}__input-wrapper` },
            react_1.default.createElement(DatePicker_1.default, Object.assign({}, date, { placeholder: placeholder, readOnly: readOnly, onChange: readOnly ? undefined : setValue, value: value })))));
};
exports.default = withCondition_1.default(DateTime);
