"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const RenderFields_1 = __importDefault(require("../../RenderFields"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const FieldTypeGutter_1 = __importDefault(require("../../FieldTypeGutter"));
const context_1 = require("../../FieldTypeGutter/context");
require("./index.scss");
const baseClass = 'group';
const Group = (props) => {
    const { label, fields, name, path: pathFromProps, fieldTypes, admin: { readOnly, style, width, }, permissions, } = props;
    const path = pathFromProps || name;
    return (react_1.default.createElement("div", { className: "field-type group", style: {
            ...style,
            width,
        } },
        react_1.default.createElement(FieldTypeGutter_1.default, null),
        react_1.default.createElement("div", { className: `${baseClass}__content-wrapper` },
            label && (react_1.default.createElement("h2", { className: `${baseClass}__title` }, label)),
            react_1.default.createElement("div", { className: `${baseClass}__fields-wrapper` },
                react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: false },
                    react_1.default.createElement(RenderFields_1.default, { permissions: permissions?.fields, readOnly: readOnly, fieldTypes: fieldTypes, fieldSchema: fields.map((subField) => ({
                            ...subField,
                            path: `${path}${subField.name ? `.${subField.name}` : ''}`,
                        })) }))))));
};
exports.default = withCondition_1.default(Group);
