"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const Error_1 = __importDefault(require("../../Error"));
const Label_1 = __importDefault(require("../../Label"));
const RadioInput_1 = __importDefault(require("./RadioInput"));
const validations_1 = require("../../../../../fields/validations");
const types_1 = require("../../../../../fields/config/types");
require("./index.scss");
const baseClass = 'radio-group';
const RadioGroup = (props) => {
    const { name, path: pathFromProps, required, validate = validations_1.radio, label, admin: { readOnly, layout = 'horizontal', style, width, } = {}, options, } = props;
    const path = pathFromProps || name;
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { required, options });
        return validationResult;
    }, [validate, required, options]);
    const { value, showError, errorMessage, setValue, } = useFieldType_1.default({
        path,
        validate: memoizedValidate,
    });
    const classes = [
        'field-type',
        baseClass,
        `${baseClass}--layout-${layout}`,
        showError && 'error',
        readOnly && `${baseClass}--read-only`,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes, style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: path, label: label, required: required }),
        react_1.default.createElement("ul", { className: `${baseClass}--group` }, options.map((option) => {
            let optionValue = '';
            if (types_1.optionIsObject(option)) {
                optionValue = option.value;
            }
            else {
                optionValue = option;
            }
            const isSelected = String(optionValue) === String(value);
            return (react_1.default.createElement("li", { key: `${path} - ${optionValue}` },
                react_1.default.createElement(RadioInput_1.default, { path: path, isSelected: isSelected, option: types_1.optionIsObject(option) ? option : { label: option, value: option }, onChange: readOnly ? undefined : setValue })));
        }))));
};
exports.default = withCondition_1.default(RadioGroup);
