"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const slate_react_1 = require("slate-react");
const window_info_1 = require("@faceless-ui/window-info");
const slate_1 = require("slate");
const Button_1 = __importDefault(require("../Button"));
const utilities_1 = require("./utilities");
const Link_1 = __importDefault(require("../../../../../icons/Link"));
const Portal_1 = __importDefault(require("../../../../../utilities/Portal"));
const Popup_1 = __importDefault(require("../../../../../elements/Popup"));
const Button_2 = __importDefault(require("../../../../../elements/Button"));
const Check_1 = __importDefault(require("../../../../../icons/Check"));
const Error_1 = __importDefault(require("../../../../Error"));
const getOffsetTop_1 = __importDefault(require("../../../../../../utilities/getOffsetTop"));
require("./index.scss");
const baseClass = 'rich-text-link';
const Link = ({ attributes, children, element }) => {
    const editor = slate_react_1.useSlate();
    const linkRef = react_1.useRef(null);
    const { height: windowHeight, width: windowWidth } = window_info_1.useWindowInfo();
    const [left, setLeft] = react_1.useState(0);
    const [top, setTop] = react_1.useState(0);
    const [error, setError] = react_1.useState(false);
    const [width, setWidth] = react_1.useState(0);
    const [height, setHeight] = react_1.useState(0);
    const [url, setURL] = react_1.useState(element.url);
    const [newTab, setNewTab] = react_1.useState(Boolean(element.newTab));
    const calculatePosition = react_1.useCallback(() => {
        if (linkRef?.current) {
            const rect = linkRef.current.getBoundingClientRect();
            const offsetTop = getOffsetTop_1.default(linkRef.current);
            setTop(offsetTop);
            setLeft(rect.left);
            setWidth(rect.width);
            setHeight(rect.height);
        }
    }, []);
    react_1.useEffect(() => {
        calculatePosition();
    }, [children, calculatePosition, windowHeight, windowWidth]);
    react_1.useEffect(() => {
        const path = slate_react_1.ReactEditor.findPath(editor, element);
        slate_1.Transforms.setNodes(editor, { url, newTab }, { at: path });
    }, [url, newTab, editor, element]);
    return (react_1.default.createElement("span", Object.assign({ className: baseClass }, attributes),
        react_1.default.createElement("span", { ref: linkRef },
            react_1.default.createElement(Portal_1.default, null,
                react_1.default.createElement("div", { className: `${baseClass}__popup-wrap`, style: {
                        width,
                        height,
                        top,
                        left,
                    } },
                    react_1.default.createElement(Popup_1.default, { initActive: url === undefined, buttonType: "custom", button: react_1.default.createElement("span", { className: `${baseClass}__button` }), size: "small", color: "dark", horizontalAlign: "center", onToggleOpen: calculatePosition, render: ({ close }) => (react_1.default.createElement(react_1.Fragment, null,
                            react_1.default.createElement("div", { className: `${baseClass}__url-wrap` },
                                react_1.default.createElement("input", { value: url || '', className: `${baseClass}__url`, placeholder: "Enter a URL", onChange: (e) => {
                                        const { value } = e.target;
                                        if (value && error) {
                                            setError(false);
                                        }
                                        setURL(value);
                                    }, onKeyDown: (e) => {
                                        if (e.key === 'Enter') {
                                            close();
                                        }
                                    } }),
                                react_1.default.createElement(Button_2.default, { className: `${baseClass}__confirm`, buttonStyle: "none", icon: "chevron", onClick: (e) => {
                                        e.preventDefault();
                                        if (url) {
                                            close();
                                        }
                                        else {
                                            setError(true);
                                        }
                                    } }),
                                error && (react_1.default.createElement(Error_1.default, { showError: error, message: "Please enter a valid URL." }))),
                            react_1.default.createElement(Button_2.default, { className: [`${baseClass}__new-tab`, newTab && `${baseClass}__new-tab--checked`].filter(Boolean).join(' '), buttonStyle: "none", onClick: () => setNewTab(!newTab) },
                                react_1.default.createElement(Check_1.default, null),
                                "Open link in new tab"))) }))),
            children)));
};
const LinkButton = () => {
    const editor = slate_react_1.useSlate();
    return (react_1.default.createElement(Button_1.default, { format: "link", onClick: () => utilities_1.wrapLink(editor) },
        react_1.default.createElement(Link_1.default, null)));
};
const link = {
    Button: LinkButton,
    Element: Link,
    plugins: [
        utilities_1.withLinks,
    ],
};
exports.default = link;
