"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const context_1 = require("../../../../../../Form/context");
const Relationship_1 = __importDefault(require("../../../../../Relationship"));
const Number_1 = __importDefault(require("../../../../../Number"));
const Select_1 = __importDefault(require("../../../../../Select"));
const createOptions = (collections, permissions) => collections.reduce((options, collection) => {
    if (permissions?.collections?.[collection.slug]?.read?.permission && collection?.admin?.enableRichTextRelationship) {
        return [
            ...options,
            {
                label: collection.labels.plural,
                value: collection.slug,
            },
        ];
    }
    return options;
}, []);
const RelationshipFields = () => {
    const { collections, maxDepth } = config_provider_1.useConfig();
    const { permissions } = config_provider_1.useAuth();
    const [options, setOptions] = react_1.useState(() => createOptions(collections, permissions));
    const { getData } = context_1.useWatchForm();
    const { relationTo } = getData();
    react_1.useEffect(() => {
        setOptions(createOptions(collections, permissions));
    }, [collections, permissions]);
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(Select_1.default, { required: true, label: "Relation To", name: "relationTo", options: options }),
        relationTo && (react_1.default.createElement(Relationship_1.default, { label: "Related Document", name: "value", relationTo: relationTo, required: true })),
        react_1.default.createElement(Number_1.default, { required: true, name: "depth", label: "Depth", min: 0, max: maxDepth })));
};
exports.default = RelationshipFields;
