"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const modal_1 = require("@faceless-ui/modal");
const slate_1 = require("slate");
const slate_react_1 = require("slate-react");
const config_provider_1 = require("@payloadcms/config-provider");
const Button_1 = __importDefault(require("../../Button"));
const Relationship_1 = __importDefault(require("../../../../../../icons/Relationship"));
const Form_1 = __importDefault(require("../../../../../Form"));
const Minimal_1 = __importDefault(require("../../../../../../templates/Minimal"));
const Button_2 = __importDefault(require("../../../../../../elements/Button"));
const Submit_1 = __importDefault(require("../../../../../Submit"));
const X_1 = __importDefault(require("../../../../../../icons/X"));
const Fields_1 = __importDefault(require("./Fields"));
const api_1 = require("../../../../../../../api");
require("./index.scss");
const initialFormData = {
    depth: 0,
};
const baseClass = 'relationship-rich-text-button';
const insertRelationship = (editor, { value, relationTo, depth }) => {
    const text = { text: ' ' };
    const relationship = {
        type: 'relationship',
        value,
        depth,
        relationTo,
        children: [
            text,
        ],
    };
    const nodes = [relationship, { children: [{ text: '' }] }];
    slate_1.Transforms.insertNodes(editor, nodes);
};
const RelationshipButton = ({ path }) => {
    const { open, closeAll } = modal_1.useModal();
    const editor = slate_react_1.useSlate();
    const { serverURL, routes: { api }, collections } = config_provider_1.useConfig();
    const [loading, setLoading] = react_1.useState(false);
    const [hasEnabledCollections] = react_1.useState(() => collections.find(({ admin: { enableRichTextRelationship } }) => enableRichTextRelationship));
    const handleAddRelationship = react_1.useCallback(async (_, { relationTo, value, depth }) => {
        setLoading(true);
        const res = await api_1.requests.get(`${serverURL}${api}/${relationTo}/${value}?depth=${depth}`);
        const json = await res.json();
        insertRelationship(editor, { value: json, depth, relationTo });
        closeAll();
    }, [editor, closeAll, api, serverURL]);
    const modalSlug = `${path}-add-relationship`;
    if (!hasEnabledCollections)
        return null;
    return (react_1.default.createElement(react_1.Fragment, null,
        react_1.default.createElement(Button_1.default, { className: baseClass, format: "relationship", onClick: () => open(modalSlug) },
            react_1.default.createElement(Relationship_1.default, null)),
        react_1.default.createElement(modal_1.Modal, { slug: modalSlug, className: `${baseClass}__modal` },
            react_1.default.createElement(Minimal_1.default, null,
                react_1.default.createElement("header", { className: `${baseClass}__header` },
                    react_1.default.createElement("h3", null, "Add Relationship"),
                    react_1.default.createElement(Button_2.default, { buttonStyle: "none", onClick: closeAll },
                        react_1.default.createElement(X_1.default, null))),
                react_1.default.createElement(Form_1.default, { onSubmit: handleAddRelationship, initialData: initialFormData, disabled: loading },
                    react_1.default.createElement(Fields_1.default, null),
                    react_1.default.createElement(Submit_1.default, null, "Add relationship"))))));
};
exports.default = RelationshipButton;
