"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const slate_1 = require("slate");
const isActive_1 = __importDefault(require("./isActive"));
const listTypes_1 = __importDefault(require("./listTypes"));
const toggleElement = (editor, format) => {
    const isActive = isActive_1.default(editor, format);
    const isList = listTypes_1.default.includes(format);
    slate_1.Transforms.unwrapNodes(editor, {
        match: (n) => listTypes_1.default.includes(n.type),
        split: true,
    });
    let type = format;
    if (isActive) {
        type = 'p';
    }
    else if (isList) {
        type = 'li';
    }
    slate_1.Transforms.setNodes(editor, { type });
    if (!isActive && isList) {
        const block = { type: format, children: [] };
        slate_1.Transforms.wrapNodes(editor, block);
    }
};
exports.default = toggleElement;
