"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const RenderFields_1 = __importDefault(require("../../RenderFields"));
const withCondition_1 = __importDefault(require("../../withCondition"));
require("./index.scss");
const Row = (props) => {
    const { fields, fieldTypes, path, permissions, admin: { readOnly, }, } = props;
    return (react_1.default.createElement(RenderFields_1.default, { readOnly: readOnly, className: "field-type row", permissions: permissions?.fields, fieldTypes: fieldTypes, fieldSchema: fields.map((field) => ({
            ...field,
            path: `${path ? `${path}.` : ''}${field.name}`,
        })) }));
};
exports.default = withCondition_1.default(Row);
