"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const ReactSelect_1 = __importDefault(require("../../../elements/ReactSelect"));
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const Label_1 = __importDefault(require("../../Label"));
const Error_1 = __importDefault(require("../../Error"));
const validations_1 = require("../../../../../fields/validations");
require("./index.scss");
const baseClass = 'select';
const formatOptions = (options) => options.map((option) => {
    if (typeof option === 'object' && option.value) {
        return option;
    }
    return {
        label: option,
        value: option,
    };
});
const Select = (props) => {
    const { path: pathFromProps, name, required, validate = validations_1.select, label, options: optionsFromProps, hasMany, admin: { readOnly, style, width, } = {}, } = props;
    const path = pathFromProps || name;
    const [options] = react_1.useState(formatOptions(optionsFromProps));
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { required, options });
        return validationResult;
    }, [validate, required, options]);
    const { value, showError, setValue, errorMessage, } = useFieldType_1.default({
        path,
        validate: memoizedValidate,
    });
    const classes = [
        'field-type',
        baseClass,
        showError && 'error',
        readOnly && `${baseClass}--read-only`,
    ].filter(Boolean).join(' ');
    let valueToRender;
    if (hasMany && Array.isArray(value)) {
        valueToRender = value.map((val) => options.find((option) => option.value === val));
    }
    else {
        valueToRender = options.find((option) => option.value === value);
    }
    return (react_1.default.createElement("div", { className: classes, style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: path, label: label, required: required }),
        react_1.default.createElement(ReactSelect_1.default, { onChange: !readOnly ? (selectedOption) => {
                if (hasMany) {
                    if (Array.isArray(selectedOption)) {
                        setValue(selectedOption.map((option) => option.value));
                    }
                    else {
                        setValue([]);
                    }
                }
                else {
                    setValue(selectedOption.value);
                }
            } : undefined, value: valueToRender, showError: showError, isDisabled: readOnly, options: options, isMulti: hasMany })));
};
exports.default = withCondition_1.default(Select);
