"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const modal_1 = require("@faceless-ui/modal");
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../../../templates/Minimal"));
const Form_1 = __importDefault(require("../../../Form"));
const Button_1 = __importDefault(require("../../../../elements/Button"));
const RenderFields_1 = __importDefault(require("../../../RenderFields"));
const Submit_1 = __importDefault(require("../../../Submit"));
const Upload_1 = __importDefault(require("../../../../views/collections/Edit/Upload"));
const context_1 = require("../../../FieldTypeGutter/context");
require("./index.scss");
const baseClass = 'add-upload-modal';
const AddUploadModal = (props) => {
    const { collection, slug, fieldTypes, setValue, } = props;
    const { permissions } = config_provider_1.useAuth();
    const { serverURL, routes: { api } } = config_provider_1.useConfig();
    const { closeAll } = modal_1.useModal();
    const onSuccess = react_1.useCallback((json) => {
        closeAll();
        setValue(json.doc);
    }, [closeAll, setValue]);
    const classes = [
        baseClass,
    ].filter(Boolean).join(' ');
    const collectionPermissions = permissions?.collections?.[collection.slug]?.fields;
    return (react_1.default.createElement(modal_1.Modal, { className: classes, slug: slug },
        react_1.default.createElement(Minimal_1.default, { width: "wide" },
            react_1.default.createElement(Form_1.default, { method: "post", action: `${serverURL}${api}/${collection.slug}`, onSuccess: onSuccess, disableSuccessStatus: true },
                react_1.default.createElement("header", { className: `${baseClass}__header` },
                    react_1.default.createElement("h1", null,
                        "New",
                        ' ',
                        collection.labels.singular),
                    react_1.default.createElement(Submit_1.default, null, "Save"),
                    react_1.default.createElement(Button_1.default, { icon: "x", round: true, buttonStyle: "icon-label", iconStyle: "with-border", onClick: closeAll })),
                react_1.default.createElement(Upload_1.default, Object.assign({}, collection.upload)),
                react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: true },
                    react_1.default.createElement(RenderFields_1.default, { permissions: collectionPermissions, readOnly: false, fieldTypes: fieldTypes, fieldSchema: collection.fields }))))));
};
exports.default = AddUploadModal;
