"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const modal_1 = require("@faceless-ui/modal");
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../../../templates/Minimal"));
const Button_1 = __importDefault(require("../../../../elements/Button"));
const formatFields_1 = __importDefault(require("../../../../views/collections/List/formatFields"));
const usePayloadAPI_1 = __importDefault(require("../../../../../hooks/usePayloadAPI"));
const ListControls_1 = __importDefault(require("../../../../elements/ListControls"));
const Paginator_1 = __importDefault(require("../../../../elements/Paginator"));
const UploadGallery_1 = __importDefault(require("../../../../elements/UploadGallery"));
require("./index.scss");
const baseClass = 'select-existing-upload-modal';
const SelectExistingUploadModal = (props) => {
    const { setValue, collection, collection: { slug: collectionSlug, } = {}, slug: modalSlug, } = props;
    const { serverURL, routes: { api } } = config_provider_1.useConfig();
    const { closeAll, currentModal } = modal_1.useModal();
    const [fields, setFields] = react_1.useState(collection.fields);
    const [listControls, setListControls] = react_1.useState({});
    const [page, setPage] = react_1.useState(null);
    const [sort, setSort] = react_1.useState(null);
    const classes = [
        baseClass,
    ].filter(Boolean).join(' ');
    const isOpen = currentModal === modalSlug;
    const apiURL = isOpen ? `${serverURL}${api}/${collectionSlug}` : null;
    const [{ data }, { setParams }] = usePayloadAPI_1.default(apiURL, {});
    react_1.useEffect(() => {
        setFields(formatFields_1.default(collection));
    }, [collection]);
    react_1.useEffect(() => {
        const params = {};
        if (page)
            params.page = page;
        if (listControls?.where)
            params.where = listControls.where;
        if (sort)
            params.sort = sort;
        setParams(params);
    }, [setParams, page, listControls, sort]);
    return (react_1.default.createElement(modal_1.Modal, { className: classes, slug: modalSlug }, isOpen && (react_1.default.createElement(Minimal_1.default, { width: "wide" },
        react_1.default.createElement("header", { className: `${baseClass}__header` },
            react_1.default.createElement("h1", null,
                ' ',
                "Select existing",
                ' ',
                collection.labels.singular),
            react_1.default.createElement(Button_1.default, { icon: "x", round: true, buttonStyle: "icon-label", iconStyle: "with-border", onClick: closeAll })),
        react_1.default.createElement(ListControls_1.default, { handleChange: setListControls, collection: {
                ...collection,
                fields,
            }, enableColumns: false, setSort: setSort, enableSort: true }),
        react_1.default.createElement(UploadGallery_1.default, { docs: data?.docs, collection: collection, onCardClick: (doc) => {
                setValue(doc);
                closeAll();
            } }),
        react_1.default.createElement("div", { className: `${baseClass}__page-controls` },
            react_1.default.createElement(Paginator_1.default, { limit: data.limit, totalPages: data.totalPages, page: data.page, hasPrevPage: data.hasPrevPage, hasNextPage: data.hasNextPage, prevPage: data.prevPage, nextPage: data.nextPage, numberOfNeighbors: 1, onChange: setPage, disableHistoryChange: true }),
            data?.totalDocs > 0 && (react_1.default.createElement("div", { className: `${baseClass}__page-info` },
                data.page,
                "-",
                data.totalPages > 1 ? data.limit : data.totalDocs,
                ' ',
                "of",
                ' ',
                data.totalDocs)))))));
};
exports.default = SelectExistingUploadModal;
