"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const modal_1 = require("@faceless-ui/modal");
const config_provider_1 = require("@payloadcms/config-provider");
const useFieldType_1 = __importDefault(require("../../useFieldType"));
const withCondition_1 = __importDefault(require("../../withCondition"));
const Button_1 = __importDefault(require("../../../elements/Button"));
const Label_1 = __importDefault(require("../../Label"));
const Error_1 = __importDefault(require("../../Error"));
const validations_1 = require("../../../../../fields/validations");
const FileDetails_1 = __importDefault(require("../../../elements/FileDetails"));
const Add_1 = __importDefault(require("./Add"));
const SelectExisting_1 = __importDefault(require("./SelectExisting"));
require("./index.scss");
const baseClass = 'upload';
const Upload = (props) => {
    const { toggle } = modal_1.useModal();
    const [internalValue, setInternalValue] = react_1.useState(undefined);
    const [missingFile, setMissingFile] = react_1.useState(false);
    const { collections, serverURL, routes: { api } } = config_provider_1.useConfig();
    const { path: pathFromProps, name, required, admin: { readOnly, style, width, } = {}, label, validate = validations_1.upload, relationTo, fieldTypes, } = props;
    const collection = collections.find((coll) => coll.slug === relationTo);
    const path = pathFromProps || name;
    const addModalSlug = `${path}-add`;
    const selectExistingModalSlug = `${path}-select-existing`;
    const memoizedValidate = react_1.useCallback((value) => {
        const validationResult = validate(value, { required });
        return validationResult;
    }, [validate, required]);
    const fieldType = useFieldType_1.default({
        path,
        validate: memoizedValidate,
    });
    const { value, showError, setValue, errorMessage, } = fieldType;
    const classes = [
        'field-type',
        baseClass,
        showError && 'error',
        readOnly && 'read-only',
    ].filter(Boolean).join(' ');
    react_1.useEffect(() => {
        if (typeof value === 'string') {
            const fetchFile = async () => {
                const response = await fetch(`${serverURL}${api}/${relationTo}/${value}`);
                if (response.ok) {
                    const json = await response.json();
                    setInternalValue(json);
                }
                else {
                    setInternalValue(undefined);
                    setValue(null);
                    setMissingFile(true);
                }
            };
            fetchFile();
        }
    }, [value, setInternalValue, relationTo, api, serverURL, setValue]);
    return (react_1.default.createElement("div", { className: classes, style: {
            ...style,
            width,
        } },
        react_1.default.createElement(Error_1.default, { showError: showError, message: errorMessage }),
        react_1.default.createElement(Label_1.default, { htmlFor: path, label: label, required: required }),
        collection?.upload && (react_1.default.createElement(react_1.default.Fragment, null,
            (internalValue && !missingFile) && (react_1.default.createElement(FileDetails_1.default, Object.assign({}, collection.upload, internalValue, { handleRemove: () => {
                    setInternalValue(undefined);
                    setValue(null);
                } }))),
            (!value || missingFile) && (react_1.default.createElement("div", { className: `${baseClass}__wrap` },
                react_1.default.createElement(Button_1.default, { buttonStyle: "secondary", onClick: () => {
                        toggle(addModalSlug);
                    } },
                    "Upload new",
                    ' ',
                    collection.labels.singular),
                react_1.default.createElement(Button_1.default, { buttonStyle: "secondary", onClick: () => {
                        toggle(selectExistingModalSlug);
                    } }, "Choose from existing"))),
            react_1.default.createElement(Add_1.default, Object.assign({}, {
                collection,
                slug: addModalSlug,
                fieldTypes,
                setValue: (val) => {
                    setMissingFile(false);
                    setValue(val.id);
                    setInternalValue(val);
                },
            })),
            react_1.default.createElement(SelectExisting_1.default, Object.assign({}, {
                collection,
                slug: selectExistingModalSlug,
                setValue: (val) => {
                    setMissingFile(false);
                    setValue(val.id);
                    setInternalValue(val);
                },
                addModalSlug,
            }))))));
};
exports.default = withCondition_1.default(Upload);
