"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const context_1 = require("../Form/context");
const withCondition = (Field) => {
    const CheckForCondition = (props) => {
        const { admin: { condition, } = {}, } = props;
        if (condition) {
            return react_1.default.createElement(WithCondition, Object.assign({}, props));
        }
        return react_1.default.createElement(Field, Object.assign({}, props));
    };
    const WithCondition = (props) => {
        const { name, path: pathFromProps, admin: { condition, } = {}, } = props;
        const path = pathFromProps || name;
        const { getData, getSiblingData, getField, dispatchFields } = context_1.useWatchForm();
        const data = getData();
        const field = getField(path);
        const siblingData = getSiblingData(path);
        const passesCondition = condition ? condition(data, siblingData) : true;
        const fieldExists = Boolean(field);
        react_1.useEffect(() => {
            if (!passesCondition && fieldExists) {
                dispatchFields({ type: 'REMOVE', path });
            }
        }, [dispatchFields, passesCondition, path, fieldExists]);
        if (passesCondition) {
            return react_1.default.createElement(Field, Object.assign({}, props));
        }
        return null;
    };
    return CheckForCondition;
};
exports.default = withCondition;
