"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_navigation_prompt_1 = __importDefault(require("react-router-navigation-prompt"));
const config_provider_1 = require("@payloadcms/config-provider");
const context_1 = require("../../forms/Form/context");
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Button_1 = __importDefault(require("../../elements/Button"));
require("./index.scss");
const modalSlug = 'leave-without-saving';
const LeaveWithoutSaving = () => {
    const modified = context_1.useFormModified();
    const { user } = config_provider_1.useAuth();
    return (react_1.default.createElement(react_router_navigation_prompt_1.default, { when: Boolean(modified && user) }, ({ onConfirm, onCancel }) => (react_1.default.createElement("div", { className: modalSlug },
        react_1.default.createElement(Minimal_1.default, null,
            react_1.default.createElement("h1", null, "Leave without saving"),
            react_1.default.createElement("p", null, "Your changes have not been saved. If you leave now, you will lose your changes."),
            react_1.default.createElement(Button_1.default, { onClick: onCancel, buttonStyle: "secondary" }, "Stay on this page"),
            react_1.default.createElement(Button_1.default, { onClick: onConfirm }, "Leave anyway"))))));
};
exports.default = LeaveWithoutSaving;
