"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const modal_1 = require("@faceless-ui/modal");
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Button_1 = __importDefault(require("../../elements/Button"));
require("./index.scss");
const baseClass = 'stay-logged-in';
const StayLoggedInModal = (props) => {
    const { refreshCookie } = props;
    const history = react_router_dom_1.useHistory();
    const { routes: { admin } } = config_provider_1.useConfig();
    const { closeAll: closeAllModals } = modal_1.useModal();
    return (react_1.default.createElement(modal_1.Modal, { className: baseClass, slug: "stay-logged-in" },
        react_1.default.createElement(Minimal_1.default, null,
            react_1.default.createElement("h1", null, "Stay logged in"),
            react_1.default.createElement("p", null, "You haven't been active in a little while and will shortly be automatically logged out for your own security. Would you like to stay logged in?"),
            react_1.default.createElement("div", { className: `${baseClass}__actions` },
                react_1.default.createElement(Button_1.default, { buttonStyle: "secondary", onClick: () => {
                        closeAllModals();
                        history.push(`${admin}/logout`);
                    } }, "Log out"),
                react_1.default.createElement(Button_1.default, { onClick: () => {
                        refreshCookie();
                        closeAllModals();
                    } }, "Stay logged in")))));
};
exports.default = StayLoggedInModal;
