"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const Nav_1 = __importDefault(require("../../elements/Nav"));
const StepNav_1 = require("../../elements/StepNav");
const RenderCustomComponent_1 = __importDefault(require("../../utilities/RenderCustomComponent"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
require("./index.scss");
const baseClass = 'template-default';
const Default = ({ children, className }) => {
    const { admin: { components: { Nav: CustomNav, } = {
        Nav: undefined,
    }, } = {}, } = config_provider_1.useConfig();
    const classes = [
        baseClass,
        className,
    ].filter(Boolean).join(' ');
    return (react_1.default.createElement("div", { className: classes },
        react_1.default.createElement(StepNav_1.StepNavProvider, null,
            react_1.default.createElement(Meta_1.default, { title: "Dashboard", description: "Dashboard for Payload CMS", keywords: "Dashboard, Payload, CMS" }),
            react_1.default.createElement(RenderCustomComponent_1.default, { DefaultComponent: Nav_1.default, CustomComponent: CustomNav }),
            react_1.default.createElement("div", { className: `${baseClass}__wrap` }, children))));
};
exports.default = Default;
