"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLocale = exports.LocaleProvider = void 0;
const react_1 = __importStar(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const SearchParams_1 = require("../SearchParams");
const Context = react_1.createContext('');
const LocaleProvider = ({ children }) => {
    const { localization } = config_provider_1.useConfig();
    const defaultLocale = (localization && localization.defaultLocale) ? localization.defaultLocale : 'en';
    const [locale, setLocale] = react_1.useState(defaultLocale);
    const searchParams = SearchParams_1.useSearchParams();
    const localeFromParams = searchParams.locale;
    react_1.useEffect(() => {
        if (localeFromParams && localization.locales.indexOf(localeFromParams) > -1)
            setLocale(localeFromParams);
    }, [localeFromParams, localization]);
    return (react_1.default.createElement(Context.Provider, { value: locale }, children));
};
exports.LocaleProvider = LocaleProvider;
const useLocale = () => react_1.useContext(Context);
exports.useLocale = useLocale;
exports.default = Context;
