"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const StepNav_1 = require("../../elements/StepNav");
const usePayloadAPI_1 = __importDefault(require("../../../hooks/usePayloadAPI"));
const Locale_1 = require("../../utilities/Locale");
const Default_1 = __importDefault(require("./Default"));
const buildStateFromSchema_1 = __importDefault(require("../../forms/Form/buildStateFromSchema"));
const RenderCustomComponent_1 = __importDefault(require("../../utilities/RenderCustomComponent"));
const context_1 = require("../../forms/FieldTypeGutter/context");
const AccountView = () => {
    const { state: locationState } = react_router_dom_1.useLocation();
    const locale = Locale_1.useLocale();
    const { setStepNav } = StepNav_1.useStepNav();
    const { user, permissions } = config_provider_1.useAuth();
    const [initialState, setInitialState] = react_1.useState({});
    const { serverURL, routes: { api }, collections, admin: { user: adminUser, components: { views: { Account: CustomAccount, } = {
        Account: undefined,
    }, } = {}, } = {
        user: 'users',
    }, } = config_provider_1.useConfig();
    const collection = collections.find((coll) => coll.slug === user.collection);
    const { fields } = collection;
    const collectionPermissions = permissions?.collections?.[adminUser];
    const [{ data, isLoading }] = usePayloadAPI_1.default(`${serverURL}${api}/${collection?.slug}/${user?.id}?depth=0`, { initialParams: { 'fallback-locale': 'null' } });
    const hasSavePermission = collectionPermissions?.update?.permission;
    const dataToRender = locationState?.data || data;
    const apiURL = `${serverURL}${api}/${user.collection}/${data?.id}`;
    const action = `${serverURL}${api}/${user.collection}/${data?.id}?locale=${locale}&depth=0`;
    react_1.useEffect(() => {
        const nav = [{
                label: 'Account',
            }];
        setStepNav(nav);
    }, [setStepNav]);
    react_1.useEffect(() => {
        const awaitInitialState = async () => {
            const state = await buildStateFromSchema_1.default(fields, dataToRender);
            setInitialState(state);
        };
        awaitInitialState();
    }, [dataToRender, fields]);
    return (react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: true },
        react_1.default.createElement(RenderCustomComponent_1.default, { DefaultComponent: Default_1.default, CustomComponent: CustomAccount, componentProps: {
                action,
                data,
                collection,
                permissions: collectionPermissions,
                hasSavePermission,
                initialState,
                apiURL,
                isLoading,
            } })));
};
exports.default = AccountView;
