"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
const Form_1 = __importDefault(require("../../forms/Form"));
const RenderFields_1 = __importDefault(require("../../forms/RenderFields"));
const field_types_1 = __importDefault(require("../../forms/field-types"));
const Submit_1 = __importDefault(require("../../forms/Submit"));
const context_1 = require("../../forms/FieldTypeGutter/context");
require("./index.scss");
const baseClass = 'create-first-user';
const CreateFirstUser = (props) => {
    const { setInitialized } = props;
    const { setToken } = config_provider_1.useAuth();
    const { admin: { user: userSlug }, collections, serverURL, routes: { admin, api }, } = config_provider_1.useConfig();
    const userConfig = collections.find((collection) => collection.slug === userSlug);
    const onSuccess = (json) => {
        if (json?.user?.token) {
            setToken(json.user.token);
        }
        setInitialized(true);
    };
    const fields = [
        {
            name: 'email',
            label: 'Email Address',
            type: 'email',
            required: true,
        }, {
            name: 'password',
            label: 'Password',
            type: 'password',
            required: true,
        },
    ];
    return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
        react_1.default.createElement("h1", null, "Welcome"),
        react_1.default.createElement("p", null, "To begin, create your first user."),
        react_1.default.createElement(Meta_1.default, { title: "Create First User", description: "Create first user", keywords: "Create, Payload, CMS" }),
        react_1.default.createElement(Form_1.default, { onSuccess: onSuccess, method: "post", redirect: admin, action: `${serverURL}${api}/${userSlug}/first-register` },
            react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: true },
                react_1.default.createElement(RenderFields_1.default, { fieldSchema: [
                        ...fields,
                        ...userConfig.fields,
                    ], fieldTypes: field_types_1.default })),
            react_1.default.createElement(Submit_1.default, null, "Create"))));
};
exports.default = CreateFirstUser;
