"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const Eyebrow_1 = __importDefault(require("../../elements/Eyebrow"));
const Card_1 = __importDefault(require("../../elements/Card"));
const Button_1 = __importDefault(require("../../elements/Button"));
require("./index.scss");
const baseClass = 'dashboard';
const Dashboard = (props) => {
    const { collections, globals, permissions, } = props;
    const { push } = react_router_dom_1.useHistory();
    const { routes: { admin, }, } = config_provider_1.useConfig();
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement(Eyebrow_1.default, null),
        react_1.default.createElement("div", { className: `${baseClass}__wrap` },
            react_1.default.createElement("h3", { className: `${baseClass}__label` }, "Collections"),
            react_1.default.createElement("ul", { className: `${baseClass}__card-list` }, collections.map((collection) => {
                const hasCreatePermission = permissions?.collections?.[collection.slug]?.create?.permission;
                return (react_1.default.createElement("li", { key: collection.slug },
                    react_1.default.createElement(Card_1.default, { title: collection.labels.plural, onClick: () => push({ pathname: `${admin}/collections/${collection.slug}` }), actions: hasCreatePermission ? (react_1.default.createElement(Button_1.default, { el: "link", to: `${admin}/collections/${collection.slug}/create`, icon: "plus", round: true, buttonStyle: "icon-label", iconStyle: "with-border" })) : undefined })));
            })),
            (globals.length > 0) && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("h3", { className: `${baseClass}__label` }, "Globals"),
                react_1.default.createElement("ul", { className: `${baseClass}__card-list` }, globals.map((global) => (react_1.default.createElement("li", { key: global.slug },
                    react_1.default.createElement(Card_1.default, { title: global.label, onClick: () => push({ pathname: `${admin}/globals/${global.slug}` }) }))))))))));
};
exports.default = Dashboard;
