"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const StepNav_1 = require("../../elements/StepNav");
const RenderCustomComponent_1 = __importDefault(require("../../utilities/RenderCustomComponent"));
const Default_1 = __importDefault(require("./Default"));
const Dashboard = () => {
    const { permissions } = config_provider_1.useAuth();
    const { setStepNav } = StepNav_1.useStepNav();
    const [filteredGlobals, setFilteredGlobals] = react_1.useState([]);
    const { collections, globals, admin: { components: { views: { Dashboard: CustomDashboard, } = {
        Dashboard: undefined,
    }, } = {}, } = {}, } = config_provider_1.useConfig();
    react_1.useEffect(() => {
        setFilteredGlobals(globals.filter((global) => permissions?.globals?.[global.slug]?.read?.permission));
    }, [permissions, globals]);
    react_1.useEffect(() => {
        setStepNav([]);
    }, [setStepNav]);
    return (react_1.default.createElement(RenderCustomComponent_1.default, { DefaultComponent: Default_1.default, CustomComponent: CustomDashboard, componentProps: {
            globals: filteredGlobals,
            collections: collections.filter((collection) => permissions?.collections?.[collection.slug]?.read?.permission),
            permissions,
        } }));
};
exports.default = Dashboard;
