"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const react_toastify_1 = require("react-toastify");
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Form_1 = __importDefault(require("../../forms/Form"));
const Email_1 = __importDefault(require("../../forms/field-types/Email"));
const Submit_1 = __importDefault(require("../../forms/Submit"));
const Button_1 = __importDefault(require("../../elements/Button"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
require("./index.scss");
const baseClass = 'forgot-password';
const ForgotPassword = () => {
    const [hasSubmitted, setHasSubmitted] = react_1.useState(false);
    const { user } = config_provider_1.useAuth();
    const { admin: { user: userSlug }, serverURL, routes: { admin, api, }, } = config_provider_1.useConfig();
    const handleResponse = (res) => {
        res.json()
            .then(() => {
            setHasSubmitted(true);
        }, () => {
            react_toastify_1.toast.error('The email provided is not valid.');
        });
    };
    if (user) {
        return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
            react_1.default.createElement(Meta_1.default, { title: "Forgot Password", description: "Forgot password", keywords: "Forgot, Password, Payload, CMS" }),
            react_1.default.createElement("h1", null, "You're already logged in"),
            react_1.default.createElement("p", null,
                "To change your password, go to your",
                ' ',
                react_1.default.createElement(react_router_dom_1.Link, { to: `${admin}/account` }, "account"),
                ' ',
                "and edit your password there."),
            react_1.default.createElement("br", null),
            react_1.default.createElement(Button_1.default, { el: "link", buttonStyle: "secondary", to: admin }, "Back to Dashboard")));
    }
    if (hasSubmitted) {
        return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
            react_1.default.createElement("h1", null, "Email sent"),
            react_1.default.createElement("p", null, "Check your email for a link that will allow you to securely reset your password.")));
    }
    return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
        react_1.default.createElement(Form_1.default, { handleResponse: handleResponse, method: "post", action: `${serverURL}${api}/${userSlug}/forgot-password` },
            react_1.default.createElement("h1", null, "Forgot Password"),
            react_1.default.createElement("p", null, "Please enter your email below. You will receive an email message with instructions on how to reset your password."),
            react_1.default.createElement(Email_1.default, { label: "Email Address", name: "email", admin: { autoComplete: 'email' }, required: true }),
            react_1.default.createElement(Submit_1.default, null, "Submit")),
        react_1.default.createElement(react_router_dom_1.Link, { to: `${admin}/login` }, "Back to login")));
};
exports.default = ForgotPassword;
