"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const format_1 = __importDefault(require("date-fns/format"));
const Eyebrow_1 = __importDefault(require("../../elements/Eyebrow"));
const Form_1 = __importDefault(require("../../forms/Form"));
const PreviewButton_1 = __importDefault(require("../../elements/PreviewButton"));
const Submit_1 = __importDefault(require("../../forms/Submit"));
const RenderFields_1 = __importDefault(require("../../forms/RenderFields"));
const CopyToClipboard_1 = __importDefault(require("../../elements/CopyToClipboard"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
const field_types_1 = __importDefault(require("../../forms/field-types"));
const LeaveWithoutSaving_1 = __importDefault(require("../../modals/LeaveWithoutSaving"));
require("./index.scss");
const baseClass = 'global-edit';
const DefaultGlobalView = (props) => {
    const { global, data, onSave, permissions, action, apiURL, initialState, } = props;
    const { fields, preview, label, } = global;
    const hasSavePermission = permissions?.update?.permission;
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement(Form_1.default, { className: `${baseClass}__form`, method: "post", action: action, onSuccess: onSave, disabled: !hasSavePermission, initialState: initialState },
            react_1.default.createElement("div", { className: `${baseClass}__main` },
                react_1.default.createElement(Meta_1.default, { title: label, description: label, keywords: `${label}, Payload, CMS` }),
                react_1.default.createElement(Eyebrow_1.default, null),
                react_1.default.createElement(LeaveWithoutSaving_1.default, null),
                react_1.default.createElement("div", { className: `${baseClass}__edit` },
                    react_1.default.createElement("header", { className: `${baseClass}__header` },
                        react_1.default.createElement("h1", null,
                            "Edit",
                            ' ',
                            label)),
                    react_1.default.createElement(RenderFields_1.default, { operation: "update", readOnly: !hasSavePermission, permissions: permissions.fields, filter: (field) => (!field.admin.position || (field.admin.position && field.admin.position !== 'sidebar')), fieldTypes: field_types_1.default, fieldSchema: fields }))),
            react_1.default.createElement("div", { className: `${baseClass}__sidebar` },
                react_1.default.createElement("div", { className: `${baseClass}__sidebar-sticky` },
                    react_1.default.createElement("div", { className: `${baseClass}__sidebar-sticky-wrap` },
                        react_1.default.createElement("div", { className: `${baseClass}__document-actions${preview ? ` ${baseClass}__document-actions--with-preview` : ''}` },
                            react_1.default.createElement(PreviewButton_1.default, { generatePreviewURL: preview }),
                            hasSavePermission && (react_1.default.createElement(Submit_1.default, null, "Save"))),
                        data && (react_1.default.createElement("div", { className: `${baseClass}__api-url` },
                            react_1.default.createElement("span", { className: `${baseClass}__label` },
                                "API URL",
                                ' ',
                                react_1.default.createElement(CopyToClipboard_1.default, { value: apiURL })),
                            react_1.default.createElement("a", { href: apiURL, target: "_blank", rel: "noopener noreferrer" }, apiURL))),
                        react_1.default.createElement("div", { className: `${baseClass}__sidebar-fields` },
                            react_1.default.createElement(RenderFields_1.default, { operation: "update", readOnly: !hasSavePermission, permissions: permissions.fields, filter: (field) => field.admin.position === 'sidebar', fieldTypes: field_types_1.default, fieldSchema: fields })),
                        data && (react_1.default.createElement("ul", { className: `${baseClass}__meta` }, data.updatedAt && (react_1.default.createElement("li", null,
                            react_1.default.createElement("div", { className: `${baseClass}__label` }, "Last Modified"),
                            react_1.default.createElement("div", null, format_1.default(new Date(data.updatedAt), 'MMMM do yyyy, h:mm a'))))))))))));
};
exports.default = DefaultGlobalView;
