"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Form_1 = __importDefault(require("../../forms/Form"));
const Password_1 = __importDefault(require("../../forms/field-types/Password"));
const ConfirmPassword_1 = __importDefault(require("../../forms/field-types/ConfirmPassword"));
const Submit_1 = __importDefault(require("../../forms/Submit"));
const Button_1 = __importDefault(require("../../elements/Button"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
require("./index.scss");
const HiddenInput_1 = __importDefault(require("../../forms/field-types/HiddenInput"));
const baseClass = 'reset-password';
const ResetPassword = () => {
    const { admin: { user: userSlug }, serverURL, routes: { admin, api } } = config_provider_1.useConfig();
    const { token } = react_router_dom_1.useParams();
    const history = react_router_dom_1.useHistory();
    const { user, setToken } = config_provider_1.useAuth();
    const onSuccess = (data) => {
        if (data.token) {
            setToken(data.token);
            history.push(`${admin}`);
        }
    };
    if (user) {
        return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
            react_1.default.createElement(Meta_1.default, { title: "Reset Password", description: "Reset password", keywords: "Reset Password, Payload, CMS" }),
            react_1.default.createElement("div", { className: `${baseClass}__wrap` },
                react_1.default.createElement("h1", null, "Already logged in"),
                react_1.default.createElement("p", null,
                    "To log in with another user, you should",
                    ' ',
                    react_1.default.createElement(react_router_dom_1.Link, { to: `${admin}/logout` }, "log out"),
                    ' ',
                    "first."),
                react_1.default.createElement("br", null),
                react_1.default.createElement(Button_1.default, { el: "link", buttonStyle: "secondary", to: admin }, "Back to Dashboard"))));
    }
    return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
        react_1.default.createElement("div", { className: `${baseClass}__wrap` },
            react_1.default.createElement("h1", null, "Reset Password"),
            react_1.default.createElement(Form_1.default, { onSuccess: onSuccess, method: "post", action: `${serverURL}${api}/${userSlug}/reset-password`, redirect: admin },
                react_1.default.createElement(Password_1.default, { label: "New Password", name: "password", autoComplete: "off", required: true }),
                react_1.default.createElement(ConfirmPassword_1.default, null),
                react_1.default.createElement(HiddenInput_1.default, { name: "token", value: token }),
                react_1.default.createElement(Submit_1.default, null, "Reset Password")))));
};
exports.default = ResetPassword;
