"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const Logo_1 = __importDefault(require("../../graphics/Logo"));
const Minimal_1 = __importDefault(require("../../templates/Minimal"));
const Button_1 = __importDefault(require("../../elements/Button"));
const Meta_1 = __importDefault(require("../../utilities/Meta"));
const Login_1 = __importDefault(require("../Login"));
require("./index.scss");
const baseClass = 'verify';
const Verify = ({ collection }) => {
    const { slug: collectionSlug } = collection;
    const { user } = config_provider_1.useAuth();
    const { token } = react_router_dom_1.useParams();
    const { serverURL, routes: { admin: adminRoute }, admin: { user: adminUser } } = config_provider_1.useConfig();
    const isAdminUser = collectionSlug === adminUser;
    const [verifyResult, setVerifyResult] = react_1.useState(null);
    react_1.useEffect(() => {
        async function verifyToken() {
            const result = await fetch(`${serverURL}/api/${collectionSlug}/verify/${token}`, { method: 'POST' });
            setVerifyResult(result);
        }
        verifyToken();
    }, [setVerifyResult, collectionSlug, serverURL, token]);
    if (user) {
        return react_1.default.createElement(Login_1.default, null);
    }
    const getText = () => {
        if (verifyResult?.status === 200)
            return 'Verified Successfully';
        if (verifyResult?.status === 202)
            return 'Already Activated';
        return 'Unable To Verify';
    };
    return (react_1.default.createElement(Minimal_1.default, { className: baseClass },
        react_1.default.createElement(Meta_1.default, { title: "Verify", description: "Verify user", keywords: "Verify, Payload, CMS" }),
        react_1.default.createElement("div", { className: `${baseClass}__brand` },
            react_1.default.createElement(Logo_1.default, null)),
        react_1.default.createElement("h2", null, getText()),
        isAdminUser && verifyResult?.status === 200 && (react_1.default.createElement(Button_1.default, { el: "link", buttonStyle: "secondary", to: `${adminRoute}/login` }, "Login"))));
};
exports.default = Verify;
