"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_toastify_1 = require("react-toastify");
const config_provider_1 = require("@payloadcms/config-provider");
const Email_1 = __importDefault(require("../../../../forms/field-types/Email"));
const Password_1 = __importDefault(require("../../../../forms/field-types/Password"));
const Checkbox_1 = __importDefault(require("../../../../forms/field-types/Checkbox"));
const Button_1 = __importDefault(require("../../../../elements/Button"));
const ConfirmPassword_1 = __importDefault(require("../../../../forms/field-types/ConfirmPassword"));
const context_1 = require("../../../../forms/Form/context");
const APIKey_1 = __importDefault(require("./APIKey"));
require("./index.scss");
const baseClass = 'auth-fields';
const Auth = (props) => {
    const { useAPIKey, requirePassword, verify, collection: { slug }, email } = props;
    const [changingPassword, setChangingPassword] = react_1.useState(requirePassword);
    const { getField } = context_1.useWatchForm();
    const modified = context_1.useFormModified();
    const enableAPIKey = getField('enableAPIKey');
    react_1.useEffect(() => {
        if (!modified) {
            setChangingPassword(false);
        }
    }, [modified]);
    const { serverURL, routes: { api, }, } = config_provider_1.useConfig();
    const unlock = react_1.useCallback(async () => {
        const url = `${serverURL}${api}/${slug}/unlock`;
        const response = await fetch(url, {
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify({
                email,
            }),
            method: 'post',
        });
        if (response.status === 200) {
            react_toastify_1.toast.success('Successfully unlocked', { autoClose: 3000 });
        }
        else {
            react_toastify_1.toast.error('Successfully unlocked');
        }
    }, [serverURL, api, slug, email]);
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement(Email_1.default, { required: true, name: "email", label: "Email", admin: { autoComplete: 'email' } }),
        (changingPassword || requirePassword) && (react_1.default.createElement("div", { className: `${baseClass}__changing-password` },
            react_1.default.createElement(Password_1.default, { autoComplete: "off", required: true, name: "password", label: "New Password" }),
            react_1.default.createElement(ConfirmPassword_1.default, null),
            !requirePassword && (react_1.default.createElement(Button_1.default, { size: "small", buttonStyle: "secondary", onClick: () => setChangingPassword(false) }, "Cancel")))),
        (!changingPassword && !requirePassword) && (react_1.default.createElement(Button_1.default, { size: "small", buttonStyle: "secondary", onClick: () => setChangingPassword(true) }, "Change Password")),
        react_1.default.createElement(Button_1.default, { size: "small", buttonStyle: "secondary", onClick: () => unlock() }, "Force Unlock"),
        useAPIKey && (react_1.default.createElement("div", { className: `${baseClass}__api-key` },
            react_1.default.createElement(Checkbox_1.default, { label: "Enable API Key", name: "enableAPIKey" }),
            enableAPIKey?.value && (react_1.default.createElement(APIKey_1.default, null)))),
        verify && (react_1.default.createElement(Checkbox_1.default, { label: "Verified", name: "_verified", admin: {
                readOnly: true,
            } }))));
};
exports.default = Auth;
