"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const StepNav_1 = require("../../../elements/StepNav");
const usePayloadAPI_1 = __importDefault(require("../../../../hooks/usePayloadAPI"));
const RenderCustomComponent_1 = __importDefault(require("../../../utilities/RenderCustomComponent"));
const Default_1 = __importDefault(require("./Default"));
const buildStateFromSchema_1 = __importDefault(require("../../../forms/Form/buildStateFromSchema"));
const context_1 = require("../../../forms/FieldTypeGutter/context");
const Locale_1 = require("../../../utilities/Locale");
const EditView = (props) => {
    const { collection, isEditing } = props;
    const { slug, labels: { plural: pluralLabel, }, admin: { useAsTitle, components: { views: { Edit: CustomEdit, } = {}, } = {}, } = {}, fields, } = collection;
    const locale = Locale_1.useLocale();
    const { serverURL, routes: { admin, api } } = config_provider_1.useConfig();
    const { params: { id } = {} } = react_router_dom_1.useRouteMatch();
    const { state: locationState } = react_router_dom_1.useLocation();
    const history = react_router_dom_1.useHistory();
    const { setStepNav } = StepNav_1.useStepNav();
    const [initialState, setInitialState] = react_1.useState({});
    const { permissions } = config_provider_1.useAuth();
    const onSave = (json) => {
        history.push(`${admin}/collections/${collection.slug}/${json?.doc?.id}`, {
            status: {
                message: json.message,
                type: 'success',
            },
            data: json.doc,
        });
    };
    const [{ data, isLoading, isError }] = usePayloadAPI_1.default((isEditing ? `${serverURL}${api}/${slug}/${id}` : null), { initialParams: { 'fallback-locale': 'null', depth: 0 } });
    const dataToRender = locationState?.data || data;
    react_1.useEffect(() => {
        const nav = [{
                url: `${admin}/collections/${slug}`,
                label: pluralLabel,
            }];
        if (isEditing) {
            nav.push({
                label: dataToRender ? dataToRender[useAsTitle || 'id'] : '',
            });
        }
        else {
            nav.push({
                label: 'Create New',
            });
        }
        setStepNav(nav);
    }, [setStepNav, isEditing, pluralLabel, dataToRender, slug, useAsTitle, admin]);
    react_1.useEffect(() => {
        const awaitInitialState = async () => {
            const state = await buildStateFromSchema_1.default(fields, dataToRender);
            setInitialState(state);
        };
        awaitInitialState();
    }, [dataToRender, fields]);
    if (isError) {
        return (react_1.default.createElement(react_router_dom_1.Redirect, { to: `${admin}/not-found` }));
    }
    const collectionPermissions = permissions?.collections?.[slug];
    const apiURL = `${serverURL}${api}/${slug}/${id}`;
    const action = `${serverURL}${api}/${slug}${isEditing ? `/${id}` : ''}?locale=${locale}&depth=0&fallback-locale=null`;
    const hasSavePermission = (isEditing && collectionPermissions?.update?.permission) || (!isEditing && collectionPermissions?.create?.permission);
    return (react_1.default.createElement(context_1.NegativeFieldGutterProvider, { allow: true },
        react_1.default.createElement(RenderCustomComponent_1.default, { DefaultComponent: Default_1.default, CustomComponent: CustomEdit, componentProps: {
                isLoading,
                data: dataToRender,
                collection,
                permissions: collectionPermissions,
                isEditing,
                onSave,
                initialState,
                hasSavePermission,
                apiURL,
                action,
            } })));
};
exports.default = EditView;
