"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const config_provider_1 = require("@payloadcms/config-provider");
const RelationshipCell = (props) => {
    const { field, data: cellData } = props;
    const { relationTo } = field;
    const { collections } = config_provider_1.useConfig();
    const [data, setData] = react_1.useState();
    react_1.useEffect(() => {
        const hasManyRelations = Array.isArray(relationTo);
        if (cellData) {
            if (Array.isArray(cellData)) {
                setData(cellData.reduce((newData, value) => {
                    const relation = hasManyRelations ? value?.relationTo : relationTo;
                    const doc = hasManyRelations ? value.value : value;
                    const collection = collections.find((coll) => coll.slug === relation);
                    if (collection) {
                        const useAsTitle = collection.admin.useAsTitle ? collection.admin.useAsTitle : 'id';
                        return newData ? `${newData}, ${doc[useAsTitle]}` : doc[useAsTitle];
                    }
                    return newData;
                }, ''));
            }
            else {
                const relation = hasManyRelations ? cellData?.relationTo : relationTo;
                const doc = hasManyRelations ? cellData.value : cellData;
                const collection = collections.find((coll) => coll.slug === relation);
                if (collection) {
                    const useAsTitle = collection.admin.useAsTitle ? collection.admin.useAsTitle : 'id';
                    setData(doc[useAsTitle]);
                }
            }
        }
    }, [cellData, relationTo, field, collections]);
    return (react_1.default.createElement(react_1.default.Fragment, null, data));
};
exports.default = RelationshipCell;
