"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const RenderCustomComponent_1 = __importDefault(require("../../../../utilities/RenderCustomComponent"));
const field_types_1 = __importDefault(require("./field-types"));
const DefaultCell = (props) => {
    const { field, colIndex, collection: { slug, }, cellData, rowData: { id, } = {}, } = props;
    const { routes: { admin } } = config_provider_1.useConfig();
    let WrapElement = 'span';
    const wrapElementProps = {};
    if (colIndex === 0) {
        WrapElement = react_router_dom_1.Link;
        wrapElementProps.to = `${admin}/collections/${slug}/${id}`;
    }
    const CellComponent = field_types_1.default[field.type];
    if (!CellComponent) {
        return (react_1.default.createElement(WrapElement, Object.assign({}, wrapElementProps),
            (cellData === '' || typeof cellData === 'undefined') && `<No ${field.label ?? 'data'}>`,
            typeof cellData === 'string' && cellData,
            typeof cellData === 'number' && cellData,
            typeof cellData === 'object' && JSON.stringify(cellData)));
    }
    return (react_1.default.createElement(WrapElement, Object.assign({}, wrapElementProps),
        react_1.default.createElement(CellComponent, { field: field, data: cellData })));
};
const Cell = (props) => {
    const { colIndex, collection, cellData, rowData, field, field: { admin: { components: { Cell: CustomCell, } = {}, } = {}, }, } = props;
    return (react_1.default.createElement(RenderCustomComponent_1.default, { componentProps: {
            rowData,
            colIndex,
            cellData,
            collection,
            field,
        }, CustomComponent: CustomCell, DefaultComponent: DefaultCell }));
};
exports.default = Cell;
