"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const UploadGallery_1 = __importDefault(require("../../../elements/UploadGallery"));
const Eyebrow_1 = __importDefault(require("../../../elements/Eyebrow"));
const Paginator_1 = __importDefault(require("../../../elements/Paginator"));
const ListControls_1 = __importDefault(require("../../../elements/ListControls"));
const Pill_1 = __importDefault(require("../../../elements/Pill"));
const Button_1 = __importDefault(require("../../../elements/Button"));
const Table_1 = __importDefault(require("../../../elements/Table"));
const Meta_1 = __importDefault(require("../../../utilities/Meta"));
require("./index.scss");
const baseClass = 'collection-list';
const DefaultList = (props) => {
    const { collection, collection: { upload, slug, labels: { singular: singularLabel, plural: pluralLabel, }, }, data, newDocumentURL, setListControls, setSort, columns, hasCreatePermission, } = props;
    const { routes: { admin } } = config_provider_1.useConfig();
    const history = react_router_dom_1.useHistory();
    const { pathname, search } = react_router_dom_1.useLocation();
    return (react_1.default.createElement("div", { className: baseClass },
        react_1.default.createElement(Meta_1.default, { title: collection.labels.plural }),
        react_1.default.createElement(Eyebrow_1.default, null),
        react_1.default.createElement("div", { className: `${baseClass}__wrap` },
            react_1.default.createElement("header", { className: `${baseClass}__header` },
                react_1.default.createElement("h1", null, pluralLabel),
                hasCreatePermission && (react_1.default.createElement(Pill_1.default, { to: newDocumentURL }, "Create New"))),
            react_1.default.createElement(ListControls_1.default, { handleChange: setListControls, setSort: setSort, collection: collection, enableColumns: Boolean(!upload), enableSort: Boolean(upload) }),
            (data.docs && data.docs.length > 0) && (react_1.default.createElement(react_1.default.Fragment, { key: `${pathname}${search}` },
                !upload && (react_1.default.createElement(Table_1.default, { data: data.docs, columns: columns })),
                upload && (react_1.default.createElement(UploadGallery_1.default, { docs: data.docs, collection: collection, onCardClick: (doc) => history.push(`${admin}/collections/${slug}/${doc.id}`) })))),
            data.docs && data.docs.length === 0 && (react_1.default.createElement("div", { className: `${baseClass}__no-results` },
                react_1.default.createElement("p", null,
                    "No",
                    ' ',
                    pluralLabel,
                    ' ',
                    "found. Either no",
                    ' ',
                    pluralLabel,
                    ' ',
                    "exist yet or none match the filters you've specified above."),
                hasCreatePermission && (react_1.default.createElement(Button_1.default, { el: "link", to: newDocumentURL },
                    "Create new",
                    ' ',
                    singularLabel)))),
            react_1.default.createElement("div", { className: `${baseClass}__page-controls` },
                react_1.default.createElement(Paginator_1.default, { limit: data.limit, totalPages: data.totalPages, page: data.page, hasPrevPage: data.hasPrevPage, hasNextPage: data.hasNextPage, prevPage: data.prevPage, nextPage: data.nextPage, numberOfNeighbors: 1 }),
                data?.totalDocs > 0 && (react_1.default.createElement("div", { className: `${baseClass}__page-info` },
                    data.page,
                    "-",
                    data.totalPages > 1 ? data.limit : data.totalDocs,
                    ' ',
                    "of",
                    ' ',
                    data.totalDocs))))));
};
exports.default = DefaultList;
