"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const Cell_1 = __importDefault(require("./Cell"));
const SortColumn_1 = __importDefault(require("../../../elements/SortColumn"));
const types_1 = require("../../../../../fields/config/types");
const buildColumns = (collection, columns, setSort) => (columns || []).reduce((cols, col, colIndex) => {
    let field = null;
    const fields = [
        ...collection.fields,
        {
            name: 'id',
            type: 'text',
            label: 'ID',
        },
        {
            name: 'updatedAt',
            type: 'date',
            label: 'Updated At',
        },
        {
            name: 'createdAt',
            type: 'date',
            label: 'Created At',
        },
    ];
    fields.forEach((fieldToCheck) => {
        if (fieldToCheck.name === col) {
            field = fieldToCheck;
        }
        if (!fieldToCheck.name && types_1.fieldHasSubFields(fieldToCheck)) {
            fieldToCheck.fields.forEach((subField) => {
                if (subField.name === col) {
                    field = subField;
                }
            });
        }
        return false;
    });
    if (field) {
        return [
            ...cols,
            {
                accessor: field.name,
                components: {
                    Heading: (react_1.default.createElement(SortColumn_1.default, { label: field.label, name: field.name, handleChange: setSort, disable: field.disableSort || undefined })),
                    renderCell: (rowData, cellData) => (react_1.default.createElement(Cell_1.default, { field: field, colIndex: colIndex, collection: collection, rowData: rowData, cellData: cellData })),
                },
            },
        ];
    }
    return cols;
}, []);
exports.default = buildColumns;
