"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const qs_1 = __importDefault(require("qs"));
const react_router_dom_1 = require("react-router-dom");
const config_provider_1 = require("@payloadcms/config-provider");
const usePayloadAPI_1 = __importDefault(require("../../../../hooks/usePayloadAPI"));
const Default_1 = __importDefault(require("./Default"));
const RenderCustomComponent_1 = __importDefault(require("../../../utilities/RenderCustomComponent"));
const StepNav_1 = require("../../../elements/StepNav");
const formatFields_1 = __importDefault(require("./formatFields"));
const buildColumns_1 = __importDefault(require("./buildColumns"));
const ListView = (props) => {
    const { collection, collection: { slug, labels: { plural, }, admin: { components: { views: { List: CustomList, } = {}, } = {}, }, }, } = props;
    const { serverURL, routes: { api, admin } } = config_provider_1.useConfig();
    const { permissions } = config_provider_1.useAuth();
    const location = react_router_dom_1.useLocation();
    const { setStepNav } = StepNav_1.useStepNav();
    const [fields] = react_1.useState(() => formatFields_1.default(collection));
    const [listControls, setListControls] = react_1.useState({});
    const [columns, setColumns] = react_1.useState([]);
    const [sort, setSort] = react_1.useState(null);
    const collectionPermissions = permissions?.collections?.[slug];
    const hasCreatePermission = collectionPermissions?.create?.permission;
    const { page } = qs_1.default.parse(location.search, { ignoreQueryPrefix: true });
    const newDocumentURL = `${admin}/collections/${slug}/create`;
    const apiURL = `${serverURL}${api}/${slug}`;
    const [{ data }, { setParams }] = usePayloadAPI_1.default(apiURL, { initialParams: { depth: 0 } });
    const { columns: listControlsColumns } = listControls;
    react_1.useEffect(() => {
        const params = {
            depth: 1,
            page: undefined,
            sort: undefined,
            where: undefined,
        };
        if (page)
            params.page = page;
        if (sort)
            params.sort = sort;
        if (listControls?.where)
            params.where = listControls.where;
        setParams(params);
    }, [setParams, page, sort, listControls]);
    react_1.useEffect(() => {
        setStepNav([
            {
                label: plural,
            },
        ]);
    }, [setStepNav, plural]);
    react_1.useEffect(() => {
        setColumns(buildColumns_1.default(collection, listControlsColumns, setSort));
    }, [collection, listControlsColumns, setSort]);
    return (react_1.default.createElement(RenderCustomComponent_1.default, { DefaultComponent: Default_1.default, CustomComponent: CustomList, componentProps: {
            collection: { ...collection, fields },
            newDocumentURL,
            hasCreatePermission,
            setSort,
            setListControls,
            listControls,
            data,
            columns,
        } }));
};
exports.default = ListView;
