"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const formatName_1 = __importDefault(require("../../../graphql/utilities/formatName"));
const formatConfigNames = (results, configs) => {
    const formattedResults = { ...results };
    configs.forEach(({ slug }) => {
        const result = { ...(formattedResults[slug] || {}) };
        delete formattedResults[slug];
        formattedResults[formatName_1.default(slug)] = result;
    });
    return formattedResults;
};
async function access(_, __, context) {
    const options = {
        req: context.req,
    };
    let accessResults = await this.operations.collections.auth.access(options);
    accessResults = formatConfigNames(accessResults, this.config.collections);
    accessResults = formatConfigNames(accessResults, this.config.globals);
    return accessResults;
}
exports.default = access;
