"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const getExtractJWT_1 = __importDefault(require("../../getExtractJWT"));
function refresh(collection) {
    async function resolver(_, args, context) {
        let token;
        const extractJWT = getExtractJWT_1.default(this.config);
        token = extractJWT(context.req);
        if (args.token) {
            token = args.token;
        }
        const options = {
            collection,
            token,
            req: context.req,
            res: context.res,
        };
        const result = await this.operations.collections.auth.refresh(options);
        return result;
    }
    const refreshResolver = resolver.bind(this);
    return refreshResolver;
}
exports.default = refresh;
