"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
async function login(options) {
    const { collection: collectionSlug, req = {}, res, depth, locale, fallbackLocale, data, overrideAccess = true, showHiddenFields, } = options;
    const collection = this.collections[collectionSlug];
    const args = {
        depth,
        collection,
        overrideAccess,
        showHiddenFields,
        data,
        req: {
            ...req,
            payloadAPI: 'local',
            payload: this,
            locale: undefined,
            fallbackLocale: undefined,
        },
        res,
    };
    if (locale)
        args.req.locale = locale;
    if (fallbackLocale)
        args.req.fallbackLocale = fallbackLocale;
    return this.operations.collections.auth.login(args);
}
exports.default = login;
