"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
const getExtractJWT_1 = __importDefault(require("../getExtractJWT"));
async function me({ req }) {
    const extractJWT = getExtractJWT_1.default(this.config);
    if (req.user) {
        const requestedSlug = req.route.path.split('/').filter((r) => r !== '')[0];
        const user = { ...req.user };
        if (user.collection !== requestedSlug) {
            return {
                user: null,
            };
        }
        delete user.collection;
        const response = {
            user,
            collection: req.user.collection,
        };
        const token = extractJWT(req);
        if (token) {
            response.token = token;
            const decoded = jsonwebtoken_1.default.decode(token);
            if (decoded)
                response.exp = decoded.exp;
        }
        return response;
    }
    return {
        user: null,
    };
}
exports.default = me;
