"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
async function loginHandler(req, res, next) {
    try {
        const result = await this.operations.collections.auth.login({
            req,
            res,
            collection: req.collection,
            data: req.body,
            depth: req.query.depth,
        });
        return res.status(http_status_1.default.OK)
            .json({
            message: 'Auth Passed',
            user: result.user,
            token: result.token,
            exp: result.exp,
        });
    }
    catch (error) {
        return next(error);
    }
}
exports.default = loginHandler;
