"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_paginate_v2_1 = __importDefault(require("mongoose-paginate-v2"));
const buildQuery_1 = __importDefault(require("../mongoose/buildQuery"));
const plugin_1 = __importDefault(require("../localization/plugin"));
const buildSchema_1 = __importDefault(require("../mongoose/buildSchema"));
const buildCollectionSchema = (collection, config, schemaOptions = {}) => {
    const schema = buildSchema_1.default(collection.fields, { timestamps: collection.timestamps !== false, ...schemaOptions });
    schema.plugin(mongoose_paginate_v2_1.default)
        .plugin(buildQuery_1.default);
    if (config.localization) {
        schema.plugin(plugin_1.default, config.localization);
    }
    return schema;
};
exports.default = buildCollectionSchema;
