"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
async function create(options) {
    const { collection: collectionSlug, depth, locale, fallbackLocale, data, user, overrideAccess = true, disableVerificationEmail, showHiddenFields, } = options;
    const collection = this.collections[collectionSlug];
    return this.operations.collections.create({
        depth,
        data,
        collection,
        overrideAccess,
        disableVerificationEmail,
        showHiddenFields,
        req: {
            user,
            payloadAPI: 'local',
            locale,
            fallbackLocale,
            payload: this,
        },
    });
}
exports.default = create;
