"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
const formatSuccess_1 = __importDefault(require("../../express/responses/formatSuccess"));
async function create(req, res, next) {
    try {
        const doc = await this.operations.collections.create({
            req,
            collection: req.collection,
            data: req.body,
            depth: req.query.depth,
        });
        return res.status(http_status_1.default.CREATED).json({
            ...formatSuccess_1.default(`${req.collection.config.labels.singular} successfully created.`, 'message'),
            doc,
        });
    }
    catch (error) {
        return next(error);
    }
}
exports.default = create;
