"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
const errors_1 = require("../../errors");
async function deleteHandler(req, res, next) {
    try {
        const doc = await this.operations.collections.delete({
            req,
            collection: req.collection,
            id: req.params.id,
            depth: req.query.depth,
        });
        if (!doc) {
            return res.status(http_status_1.default.NOT_FOUND).json(new errors_1.NotFound());
        }
        return res.status(http_status_1.default.OK).send(doc);
    }
    catch (error) {
        return next(error);
    }
}
exports.default = deleteHandler;
