"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
async function find(req, res, next) {
    try {
        const options = {
            req,
            collection: req.collection,
            where: req.query.where,
            page: req.query.page,
            limit: req.query.limit,
            sort: req.query.sort,
            depth: req.query.depth,
        };
        const result = await this.operations.collections.find(options);
        return res.status(http_status_1.default.OK).json(result);
    }
    catch (error) {
        return next(error);
    }
}
exports.default = find;
