"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
const formatSuccess_1 = __importDefault(require("../../express/responses/formatSuccess"));
async function update(req, res, next) {
    try {
        const doc = await this.operations.collections.update({
            req,
            collection: req.collection,
            id: req.params.id,
            data: req.body,
            depth: req.query.depth,
        });
        return res.status(http_status_1.default.OK).json({
            ...formatSuccess_1.default('Updated successfully.', 'message'),
            doc,
        });
    }
    catch (error) {
        return next(error);
    }
}
exports.default = update;
