"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const passport_1 = __importDefault(require("passport"));
exports.default = (config) => {
    const methods = config.collections.reduce((enabledMethods, collection) => {
        if (typeof collection.auth === 'object' && collection.auth.useAPIKey) {
            const collectionMethods = [...enabledMethods];
            collectionMethods.unshift(`${collection.slug}-api-key`);
            return collectionMethods;
        }
        return enabledMethods;
    }, ['jwt', 'anonymous']);
    const authenticate = passport_1.default.authenticate(methods, { session: false });
    return authenticate;
};
