"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const passport_1 = __importDefault(require("passport"));
const path_1 = __importDefault(require("path"));
const getExecuteStaticAccess_1 = __importDefault(require("../auth/getExecuteStaticAccess"));
const authenticate_1 = __importDefault(require("./middleware/authenticate"));
function initStatic(ctx) {
    Object.entries(ctx.collections).forEach(([_, collection]) => {
        const { config } = collection;
        if (config.upload) {
            const router = express_1.default.Router();
            router.use(passport_1.default.initialize());
            router.use(authenticate_1.default(ctx.config));
            router.use(getExecuteStaticAccess_1.default(collection));
            const staticPath = path_1.default.resolve(ctx.config.paths.configDir, config.upload.staticDir);
            router.use(express_1.default.static(staticPath));
            ctx.express.use(`${config.upload.staticURL}`, router);
        }
    });
}
exports.default = initStatic;
