"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const relationshipPopulationPromise_1 = __importDefault(require("./relationshipPopulationPromise"));
const accessPromise = async ({ data, originalDoc, field, operation, overrideAccess, req, id, relationshipPopulations, depth, currentDepth, hook, payload, }) => {
    const resultingData = data;
    let accessOperation;
    if (hook === 'afterRead') {
        accessOperation = 'read';
    }
    else if (hook === 'beforeValidate') {
        if (operation === 'update')
            accessOperation = 'update';
        if (operation === 'create')
            accessOperation = 'create';
    }
    if (field.access && field.access[accessOperation]) {
        const result = overrideAccess ? true : await field.access[accessOperation]({ req, id });
        if (!result && accessOperation === 'update' && originalDoc[field.name] !== undefined) {
            resultingData[field.name] = originalDoc[field.name];
        }
        else if (!result) {
            delete resultingData[field.name];
        }
    }
    if ((field.type === 'relationship' || field.type === 'upload') && hook === 'afterRead') {
        relationshipPopulations.push(relationshipPopulationPromise_1.default({
            data,
            field,
            depth,
            currentDepth,
            req,
            overrideAccess,
            payload,
        }));
    }
};
exports.default = accessPromise;
