"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hookPromise = async ({ data, field, hook, req, operation, fullOriginalDoc, fullData, }) => {
    const resultingData = data;
    if (field.hooks && field.hooks[hook]) {
        await field.hooks[hook].reduce(async (priorHook, currentHook) => {
            await priorHook;
            const hookedValue = await currentHook({
                value: data[field.name],
                originalDoc: fullOriginalDoc,
                data: fullData,
                operation,
                req,
            }) || data[field.name];
            if (hookedValue !== undefined) {
                resultingData[field.name] = hookedValue;
            }
        }, Promise.resolve());
    }
};
exports.default = hookPromise;
