"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = __importDefault(require("mongoose"));
const buildSchema_1 = __importDefault(require("../mongoose/buildSchema"));
const plugin_1 = __importDefault(require("../localization/plugin"));
const buildModel = (config) => {
    if (config.globals && config.globals.length > 0) {
        const globalsSchema = new mongoose_1.default.Schema({}, { discriminatorKey: 'globalType', timestamps: true });
        if (config.localization) {
            globalsSchema.plugin(plugin_1.default, config.localization);
        }
        const Globals = mongoose_1.default.model('globals', globalsSchema);
        Object.values(config.globals).forEach((globalConfig) => {
            const globalSchema = buildSchema_1.default(globalConfig.fields);
            if (config.localization) {
                globalSchema.plugin(plugin_1.default, config.localization);
            }
            Globals.discriminator(globalConfig.slug, globalSchema);
        });
        return Globals;
    }
    return null;
};
exports.default = buildModel;
