"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const buildModel_1 = __importDefault(require("./buildModel"));
function initGlobals(ctx) {
    if (ctx.config.globals) {
        ctx.globals = {
            Model: buildModel_1.default(ctx.config),
            config: ctx.config.globals,
        };
        // If not local, open routes
        if (!ctx.local) {
            const router = express_1.default.Router();
            ctx.config.globals.forEach((global) => {
                router
                    .route(`/globals/${global.slug}`)
                    .get(ctx.requestHandlers.globals.findOne(global))
                    .post(ctx.requestHandlers.globals.update(global));
            });
            ctx.router.use(router);
        }
    }
}
exports.default = initGlobals;
