"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
function findOne(globalConfig) {
    async function handler(req, res, next) {
        try {
            const { slug } = globalConfig;
            const result = await this.operations.globals.findOne({
                req,
                globalConfig,
                slug,
                depth: req.query.depth,
            });
            return res.status(http_status_1.default.OK).json(result);
        }
        catch (error) {
            return next(error);
        }
    }
    const findOneHandler = handler.bind(this);
    return findOneHandler;
}
exports.default = findOne;
