"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_status_1 = __importDefault(require("http-status"));
function update(globalConfig) {
    async function handler(req, res, next) {
        try {
            const { slug } = globalConfig;
            const result = await this.operations.globals.update({
                req,
                globalConfig,
                slug,
                depth: req.query.depth,
                data: req.body,
            });
            return res.status(http_status_1.default.OK).json({ message: 'Global saved successfully.', result });
        }
        catch (error) {
            return next(error);
        }
    }
    const updateHandler = handler.bind(this);
    return updateHandler;
}
exports.default = update;
