"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const access_1 = __importDefault(require("../auth/graphql/resolvers/access"));
const forgotPassword_1 = __importDefault(require("../auth/graphql/resolvers/forgotPassword"));
const init_1 = __importDefault(require("../auth/graphql/resolvers/init"));
const login_1 = __importDefault(require("../auth/graphql/resolvers/login"));
const logout_1 = __importDefault(require("../auth/graphql/resolvers/logout"));
const me_1 = __importDefault(require("../auth/graphql/resolvers/me"));
const refresh_1 = __importDefault(require("../auth/graphql/resolvers/refresh"));
const resetPassword_1 = __importDefault(require("../auth/graphql/resolvers/resetPassword"));
const verifyEmail_1 = __importDefault(require("../auth/graphql/resolvers/verifyEmail"));
const unlock_1 = __importDefault(require("../auth/graphql/resolvers/unlock"));
const create_1 = __importDefault(require("../collections/graphql/resolvers/create"));
const find_1 = __importDefault(require("../collections/graphql/resolvers/find"));
const findByID_1 = __importDefault(require("../collections/graphql/resolvers/findByID"));
const update_1 = __importDefault(require("../collections/graphql/resolvers/update"));
const delete_1 = __importDefault(require("../collections/graphql/resolvers/delete"));
const findOne_1 = __importDefault(require("../globals/graphql/resolvers/findOne"));
const update_2 = __importDefault(require("../globals/graphql/resolvers/update"));
function bindResolvers(ctx) {
    ctx.graphQL = {
        resolvers: {
            collections: {
                create: create_1.default.bind(ctx),
                find: find_1.default.bind(ctx),
                findByID: findByID_1.default.bind(ctx),
                update: update_1.default.bind(ctx),
                deleteResolver: delete_1.default.bind(ctx),
                auth: {
                    access: access_1.default.bind(ctx),
                    forgotPassword: forgotPassword_1.default.bind(ctx),
                    init: init_1.default.bind(ctx),
                    login: login_1.default.bind(ctx),
                    logout: logout_1.default.bind(ctx),
                    me: me_1.default.bind(ctx),
                    refresh: refresh_1.default.bind(ctx),
                    resetPassword: resetPassword_1.default.bind(ctx),
                    verifyEmail: verifyEmail_1.default.bind(ctx),
                    unlock: unlock_1.default.bind(ctx),
                },
            },
            globals: {
                findOne: findOne_1.default.bind(ctx),
                update: update_2.default.bind(ctx),
            },
        },
    };
}
exports.default = bindResolvers;
