"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../utilities/logger"));
const logger = logger_1.default();
/**
 *
 * @param info
 * @param debug
 * @param afterErrorHook
 * @returns {Promise<unknown[]>}
 */
const errorHandler = async (info, debug, afterErrorHook) => Promise.all(info.result.errors.map(async (err) => {
    logger.error(err.stack);
    let response = {
        message: err.message,
        data: (err && err.originalError && err.originalError.data) || undefined,
        stack: undefined,
    };
    if (afterErrorHook) {
        ({ response } = await afterErrorHook(err, response) || { response });
    }
    if (debug && debug === true) {
        response.stack = err.stack;
    }
    return response;
}));
exports.default = errorHandler;
