"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const access_1 = __importDefault(require("../auth/operations/access"));
const forgotPassword_1 = __importDefault(require("../auth/operations/forgotPassword"));
const init_1 = __importDefault(require("../auth/operations/init"));
const login_1 = __importDefault(require("../auth/operations/login"));
const logout_1 = __importDefault(require("../auth/operations/logout"));
const me_1 = __importDefault(require("../auth/operations/me"));
const refresh_1 = __importDefault(require("../auth/operations/refresh"));
const registerFirstUser_1 = __importDefault(require("../auth/operations/registerFirstUser"));
const resetPassword_1 = __importDefault(require("../auth/operations/resetPassword"));
const verifyEmail_1 = __importDefault(require("../auth/operations/verifyEmail"));
const unlock_1 = __importDefault(require("../auth/operations/unlock"));
const create_1 = __importDefault(require("../collections/operations/create"));
const find_1 = __importDefault(require("../collections/operations/find"));
const findByID_1 = __importDefault(require("../collections/operations/findByID"));
const update_1 = __importDefault(require("../collections/operations/update"));
const delete_1 = __importDefault(require("../collections/operations/delete"));
const findOne_1 = __importDefault(require("../globals/operations/findOne"));
const update_2 = __importDefault(require("../globals/operations/update"));
function bindOperations(ctx) {
    ctx.operations = {
        collections: {
            create: create_1.default.bind(ctx),
            find: find_1.default.bind(ctx),
            findByID: findByID_1.default.bind(ctx),
            update: update_1.default.bind(ctx),
            delete: delete_1.default.bind(ctx),
            auth: {
                access: access_1.default.bind(ctx),
                forgotPassword: forgotPassword_1.default.bind(ctx),
                init: init_1.default.bind(ctx),
                login: login_1.default.bind(ctx),
                logout: logout_1.default.bind(ctx),
                me: me_1.default.bind(ctx),
                refresh: refresh_1.default.bind(ctx),
                registerFirstUser: registerFirstUser_1.default.bind(ctx),
                resetPassword: resetPassword_1.default.bind(ctx),
                verifyEmail: verifyEmail_1.default.bind(ctx),
                unlock: unlock_1.default.bind(ctx),
            },
        },
        globals: {
            findOne: findOne_1.default.bind(ctx),
            update: update_2.default.bind(ctx),
        },
    };
}
exports.default = bindOperations;
