"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const access_1 = __importDefault(require("../auth/requestHandlers/access"));
const forgotPassword_1 = __importDefault(require("../auth/requestHandlers/forgotPassword"));
const init_1 = __importDefault(require("../auth/requestHandlers/init"));
const login_1 = __importDefault(require("../auth/requestHandlers/login"));
const logout_1 = __importDefault(require("../auth/requestHandlers/logout"));
const me_1 = __importDefault(require("../auth/requestHandlers/me"));
const refresh_1 = __importDefault(require("../auth/requestHandlers/refresh"));
const registerFirstUser_1 = __importDefault(require("../auth/requestHandlers/registerFirstUser"));
const resetPassword_1 = __importDefault(require("../auth/requestHandlers/resetPassword"));
const verifyEmail_1 = __importDefault(require("../auth/requestHandlers/verifyEmail"));
const unlock_1 = __importDefault(require("../auth/requestHandlers/unlock"));
const create_1 = __importDefault(require("../collections/requestHandlers/create"));
const find_1 = __importDefault(require("../collections/requestHandlers/find"));
const findByID_1 = __importDefault(require("../collections/requestHandlers/findByID"));
const update_1 = __importDefault(require("../collections/requestHandlers/update"));
const delete_1 = __importDefault(require("../collections/requestHandlers/delete"));
const findOne_1 = __importDefault(require("../globals/requestHandlers/findOne"));
const update_2 = __importDefault(require("../globals/requestHandlers/update"));
function bindRequestHandlers(ctx) {
    ctx.requestHandlers = {
        collections: {
            create: create_1.default.bind(ctx),
            find: find_1.default.bind(ctx),
            findByID: findByID_1.default.bind(ctx),
            update: update_1.default.bind(ctx),
            delete: delete_1.default.bind(ctx),
            auth: {
                access: access_1.default.bind(ctx),
                forgotPassword: forgotPassword_1.default.bind(ctx),
                init: init_1.default.bind(ctx),
                login: login_1.default.bind(ctx),
                logout: logout_1.default.bind(ctx),
                me: me_1.default.bind(ctx),
                refresh: refresh_1.default.bind(ctx),
                registerFirstUser: registerFirstUser_1.default.bind(ctx),
                resetPassword: resetPassword_1.default.bind(ctx),
                verifyEmail: verifyEmail_1.default.bind(ctx),
                unlock: unlock_1.default.bind(ctx),
            },
        },
        globals: {
            findOne: findOne_1.default.bind(ctx),
            update: update_2.default.bind(ctx),
        },
    };
}
exports.default = bindRequestHandlers;
