"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flattenTopLevelFields = (fields) => fields.reduce((flattened, field) => {
    if (!field.name && Array.isArray(field.fields)) {
        return [
            ...flattened,
            ...field.fields.filter((subField) => subField.name),
        ];
    }
    return [
        ...flattened,
        field,
    ];
}, []);
exports.default = flattenTopLevelFields;
